/********************************************************************
		           xcde_consts.h
            contains constants needed by the XCDE Library
                     Xml Compressed Document Engine
	         Paolo Ferragina - Andrea Mastroianni 
             Dipartimento di Informatica - Universita' di Pisa 
	                  ferragin@di.unipi.it
	                mastroi@cli.di.unipi.it
********************************************************************/

#define K 1024

/*******************************************************************
                          FILES SUFFIXES 
********************************************************************/

#define XCDE_DICTIONARY_SUFFIX ".dict."

#define XCDE_HEADER_SUFFIX ".head"

#define XCDE_BODY_SUFFIX ".body"

#define XCDE_IL_SUFFIX ".il" 

#define XCDE_TAGSTRUCT_SUFFIX ".tagstruct"

#define XCDE_DEBUG_INDEX_SUFFIX ".debug.index" 

#define XCDE_DEBUG_PHYSIC_SUFFIX ".debug.physic"

#define XCDE_DEBUG_STATS_SUFFIX ".debug.stats"

/*******************************************************************
                      STANDARD CONFIGURATION FILE 
********************************************************************/

#define XCDE_CONFIGFILE_STANDARD_NAME "xcde_build.conf" 

#define XCDE_CONFIGDIR_ENV "XCDE_CONFIGDIR"

/*******************************************************************
                       BODY FILE COMPRESS BLOCK
********************************************************************/

#define XCDE_COMPRESS_BLOCK_SIZE 64*K

/*******************************************************************
        MAXIMUM NUMBER OF LIST POINTED BY AN IL TABLE INDEX ELEMENT
********************************************************************/

#define XCDE_IL_POINTER_RATIO 10

/*******************************************************************
                           OTHER CONSTANTS
********************************************************************/

#define XCDE_MAX_SEPARATORS_BLOCK  256

#define XCDE_MAX_NUMBER_SEPARATORS 256

#define XCDE_NUMBER_DICT   3

#define XCDE_CONT_BIT_BUFFER_MAX_LENGTH 10 

#define XCDE_MAX_CONF_FILE_LINE_LENGTH 256 

#define XCDE_GOLOMB_BUFFER_MAX_LENGTH 10 

#define XCDE_SYSTEM_COMAND_LENGTH K 

#define XCDE_EXPAT_PARSING_BUFFER_SIZE 64*K

#define XCDE_IL_COMPRESS_BUFFER_SIZE 5*K

#define XCDE_SEPARATORS_HT_DIMENSION 100

#define XCDE_ENTITY_HT_DIMENSION 100

#define XCDE_TEXTBUFFER_SIZE 1*K

#define XCDE_HASHTABLE_RATIO 1000

#define XCDE_HUFF_MAX_LEVEL 5

#define XCDE_RECURSIVE_TAG_PREFIX "xml_"

#define ASCII_SPACE 32

#define ASCII_E 69

#define ASCII_A 65

#define XCDE_BACKWARD          0

#define XCDE_FORWARD           1

#define XCDE_BACKWARD_FORWARD  2

#define XCDE_PREFIX        0

#define XCDE_SUFFIX        1 

#define XCDE_ERROR         2

#define XCDE_EXACT         3

#define XCDE_CONTAINED     4

#define XCDE_REGEXP        5

#define XCDE_ANYVALUE      6 

#define XCDE_TOKEN_EXACT   7

#define XCDE_TOKEN_PREFIX  8

#define XCDE_TOKEN_SUFFIX  9 

#define XCDE_CASE          0

#define XCDE_NOCASE        1


