#include "headers1.h"

void continuation_bit_c (unsigned long n, char* r, unsigned int offset, 
			 unsigned long* len)
{
  unsigned long temp;
  int           i, nbyte=0;
  char          byte,
                mask1, mask2;


  if (verifica_offset(offset)) exit(-1);

  // Calcola la lunghezza in byte della rappresentazione compressa

  temp = n;

  while (temp) {
    temp >>= 7;
    (nbyte)++;}
  
  if (nbyte == 0) nbyte = 1;  // Per la rappresentazione dello 0

  *len = nbyte * 8;
  
  byte = (char) (n & 127);

  // Prepara ed usa due maschere per scrivere '8 - offset' bit in un byte 
  // e 'offset' bit nel byte successivo senza alterare i restanti bit 
  // dei byte di destinazione.

  mask1 = (unsigned char) (((unsigned char) ~0) >> offset);
  mask2 = (unsigned char) (((unsigned char) ~0) >> (8-offset));

  // Inserisce, byte dopo byte, la rappresentazione compressa nel buffer.
  // In tutti i byte, tranne l'ultimo, setta il bit pi significativo 
  // uguale ad 1.

  r[nbyte  ] = (r[nbyte  ] &  mask1) | ((byte &  mask2) << (8-offset));
  r[nbyte-1] = (r[nbyte-1] & ~mask1) | ((byte & ~mask2) >> (  offset));

  for (i=nbyte-1; i>0; i--) {
    n = n >> 7;
    byte = (unsigned char) (128 | (n & 127));

    r[i  ] = (r[i  ] &  mask1) | ((byte &  mask2) << (8-offset));
    
    r[i-1] = (r[i-1] & (unsigned char) ~mask1) | 
      ((byte & (unsigned char) ~mask2) >> (  offset));
  }    
}


void continuation_bit_d (unsigned long* n, char* r, unsigned int offset, 
			 unsigned long* len)
{
  int                  i = 0;
  char                 mask1, mask2;


  if (verifica_offset(offset)) exit(-1);

  // Mask1  usata per selezionare i (7-offset) bit meno
  // significativi da ogni byte (eliminando il bit di continuit).
  // Mask2, invece,  usata per selezionare gli 'offset' bit pi
  // significativi dal byte successivo.

  mask1 = (unsigned char)  (((unsigned char) ~0) >> (offset+1));
  mask2 = (unsigned char) ~(((unsigned char) ~0) >>  offset   );

  // Aggiunge al decompresso il byte considerato (solo i 7 bit meno 
  // significativi). Finch il bit pi significativo vale 1 considera
  // il byte successivo.

  *n = 0;
  *len=0;

  do {
    *n = (*n << (7-offset)) |
      (unsigned char)  (r[i  ] & (unsigned char) mask1);

    *n = (*n << offset) |
      (unsigned char) ((r[i+1] & (unsigned char) mask2) >> (8-offset));

    *len += 8;
  } while (r[i++] & (1 << (7-offset)));
}
