/********************************************************************
	               textbuffer.c	    
      file con le funzioni per la gestione del buffer di testo
	       Copyright - Andrea Mastroianni
	      Corso di Laurea in Informatica
	           Universita' di Pisa
		   Versione 07-11-2001
 ********************************************************************/
// inclusione dei file di intestazione del progetto
#include"textbuffer.h"
#include<stdlib.h>
#include<stdio.h>

// inizializzazione del buffer 
int init_buffer(Textbuffer *buffer ,
		int dimension) 
{ // lunghezza del testo contenuto nel buffer
  buffer->len = 0 ; 

  // dimensioni del buffer 
  buffer->dim = dimension ; 

  if (buffer->text != NULL) 

    free(buffer->text) ; 

  // allocazione del buffer per contenere il testo 
  buffer->text = malloc(buffer->dim*sizeof(char)) ; 

  if (buffer->text) 

    return(1) ;

  else return(-1) ; 
}

// inserimento del testo nel buffer
int insert_buffer(Textbuffer *buffer,
		  char *text,
		  int dimension) 
{ // variabile usata come contatore
  int k=0 ;

 // considera l'ampiezza del buffer considerato
 // e la cambia se non e' sufficiente  
 if ( (buffer->len+dimension) > buffer->dim) 

   { // rialloca lo spazio di memoria necessario per il buffer 
     buffer->text=realloc(buffer->text, (buffer->len+dimension)*sizeof(char)) ;
     
     // verifica se si e' verificata una situazione di errore
     if ((buffer->dim != 0) && (buffer->text == NULL)) 

       return(-1) ; 
     
     // aumenta le dimensioni del buffer
     buffer->dim = buffer->len+dimension ; 
   }
 
 // inserisce il testo all'interno del buffer 
 for (k=0 ; k<dimension ; ++k)
   
   buffer->text[buffer->len+k] = text[k] ;

 // incrementa le dimensioni del buffer 
 buffer->len=buffer->len+dimension ;
 
 return(0) ;
}

int get_buffer_length(Textbuffer *buffer)
{ return(buffer->len) ; 
}

// estrae il testo dal buffer di memoria
int get_text_in_buffer(Textbuffer *buffer, 
		       char *text) 
{ // variabile contatore 
  int k=0 ; 

  // legge il testo dal buffer di memoria
  for (k=0; k<buffer->len; ++k) 

   text[k]=buffer->text[k] ;

  // la lunghezza del buffer e' posta a 0
  buffer->len=0 ;

  // restituisce il numero di elementi letti dal buffer
  return(k) ; 
}

// funzione che restituisce un flag in base al fatto che 
// il buffer sia pieno o meno 
int text_in_buffer(Textbuffer *buffer) 
{ return(buffer->len > 0) ; 
}
