/********************************************************************
     xml_confhand.c : file con gli handler del parser di clark
           utilizzati per la scrittura del file compresso 
	   Indicizzatore e compressore di file xml
	       Copyright - Andrea Mastroianni
	      Corso di Laurea in Informatica
	           Universita' di Pisa
		   Versione 06-11-2001
 ********************************************************************/
// include il file di intestazione del progetto
#include"xml_ind.h"

// flag che indica che siamo all'interno di una
// sezione CDATA
extern 
unsigned 
char Sez_Cdata ;

// flag che indica se siamo o meno all'interno di una 
// sezione CDATA che e' data dall'espansione di una 
// entita'
extern
unsigned 
char Sez_Cdata_exp_ent ; 

// ultimo byte del file compresso scritto 
// necessario per la creazione della lista 
// delle occorrenze fisiche 
extern 
int Last_body_write ;

// rango all'interno dell'espansione dell'entita' 
extern
int EntityRank ; 

// dimensione in bytes del file compresso 
extern 
int Body_size ;

// numero degli elementi attualmente aperti nell'analisi
// del file sorgente XML 
extern 
int num_tag ;

// tabella hash utilizzata per 
// la costruzione del dizionario 
extern 
HashTable ht ; 

// tabella hash utilizzata per 
// contenere informazioni sulle 
// dichiarazioni delle entita'
// generali interne 
extern 
HashTable entity ;

// tabella hash utilizzata per
// contenere le entita' interne
// o esterne che sono separatori
// dichiarate nel file di 
// configurazione dell'applicazione 
extern 
HashTable septable ; 

// puntatore utilizzato per mappare il 
// file di testo originale nella memoria
// tramite la funzione mmap 
extern 
char *ortext ;  

// puntatori utilizzati per scorrere 
// le corrispondenze logiche del file 
// sorgente xml. In pratica per analizzare
// l'espansione dei riferimenti ad entita' 
// interne 
extern 
char *xml_code ;

extern 
long xml_dim ;

extern 
long xml_pos ; 

extern 
long p_bytecount ; 

// buffer utilizzato per la bufferizzazione del 
// testo. Usato per facilitare l'analisi dei diversi
// elementi del sorgente XML  
extern 
Textbuffer textbuffer ;

// separatori utilizzati di default dal codice
// per il valore degli attributi e gli elementi 
// di testo nel sorgente XML. Possono  essere 
// cambiati utilizzando il file di configurazione 
extern 
char separatori[255] ;

// variabile per la gestione delle entita'
extern
unsigned char fis ; 

unsigned char Last_fis=0; 


// variabile che indica che un'entita'
// e' stata espansa in quella posizione
extern 
unsigned char change ; 

/*******************************************************************
  		Gestore della codifica dell'inizio del tag
*******************************************************************/
void 
startcod(void *data,
	 const char *el, 
	 const char **attr)
{ // variabili contatore 
  int j=0 ;
  int k=0 ;
  int i=0 ; 

  // variabile utilizzata per memorizzare la 
  // lunghezza dei token 
  int count=0 ;
  
  // variabili utilizzate per calcolare la 
  // lunghezza di diversi token 
  int token_len=0 ; 
  int token_len1=0 ;
  int token_len2=0 ;
  
  // variabili utilizzate per calcolare la
  // lunghezza degli attributi 
  int attr_len=0 ; 
  int tot_attr_len=0 ;
  
  // numero dei separatori trovati 
  int num_sep=0 ; 

  // stringa usata per la memorizzazione 
  // dell'identificatore del tag da inserire
  // nel dizionario 
  char tag[MAX_TAG_NAME]="\0" ; 
 
  // stringa utilizzata per la memorizzazione
  // degli attributi e dei loro valori nel 
  // dizionario 
  char token[MAX_TAG_NAME]="\0" ; 

  // stringa utilizzata per la memorizzazione
  // dei separatori 
  char sep[MAX_SEP]="\0" ;

  // separatore trovato dalla funzione get_next_token
  char separatore='\0' ;

  // stringa utilizzata per acquisire il valore degli attributi 
  char NTagNAttr[MAX_ATTR_NAME]="\0" ; 

  // contatore per determinare il numero degli elementi 
  // letti 
  long tagcount=0 ; 

  char prova_param[MAX_TAG_NAME]="\0" ; 

  char logic_token[MAX_TAG_NAME]="\0" ; 

  char entity_name[MAX_TAG_NAME]="\0" ; 
  
  char result_token[MAX_TAG_NAME]="\0" ; 

  char result[MAX_TAG_NAME]="\0" ; 

  // flag per il tag vuoto 
  unsigned char tag_vuoto=0u ; 

  int logic_len=0 ; 

  int pos_tok=0 ; 

  int pos_attr=0 ; 

  int pos_res=0 ; 

  int pos_result=0 ; 

  int attr_pos=0 ; 

  unsigned char done=0 ;

  Hashptr search=NULL ; 
 
  // svuota l'eventuale buffer presente in memoria
  // e ne considera il token come una componente logica 
  if (text_in_buffer(&textbuffer))
    
    { count=get_text_in_buffer(&textbuffer, 
			       token) ; 
    
    token[count]='\0' ; 
    
    // trasforma il token in minuscolo 
    undercase(token, count) ; 
    
    // inserimento dell'elemento nella tabella Hash 
    if (fis==1) 
      
      hinsert((char *) token,
	      count, 
	      WORD,
	      (char *) NULL, 
	      ht, 
	      Last_body_write, 
	      0,
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;  
    
    else
      
      { hinsert((char *) token,
		count,
		WORD,
		(char *) NULL,
		ht,
		Last_body_write,
		EntityRank,
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
      
      // incrementa il rango dell'entita' 
      ++EntityRank ; 
      }
    }
  
  // incrementa il numero di elementi aperti 
  // per determinare se siamo all'interno
  // dell'elemento XML 
  ++num_tag ; 

  // aggiornamento del puntatore al testo compresso 
  if (fis==1) 

    Last_body_write=Body_size ; 

  // determina se quanto contenuto nella posizione 
  // fisica dell'elemento corrisponde con la posizione
  // logica
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ; 
  
  // ultima variabile fisica 
  Last_fis=fis ; 

  if ((fis==0) && (change==1))
    
    EntityRank=1 ; 
  
  // legge il prossimo token nel file originale
  // es. 1 :
  // <elemento attributo="valore">
  // legge <elemento
  // es. 2 :
  // <elemento> 
  // legge <elemento e >
  token_len=get_next_token(xml_code+xml_pos,
			   " /\t\n>", 
			   &separatore,  
			   xml_dim-xml_pos) ; 
  
  for (k=1; k<token_len; ++k) 
    
    tag[k-1]=xml_code[xml_pos+k] ; 
  
  tag[k-1]='\0' ;
  
  if (fis==0)
    
    hinsert((char *) tag,
	    strlen(tag),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    Last_body_write,
	    EntityRank, 
	    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ;

  else
  
    // inserimento della posizione dell'elemento 
    // nel file compresso nella lista contenuta 
    // nella tabella hash 
    hinsert((char *) tag, 
	    strlen(tag),
	    TAG,
	    (char *) NULL, 
	    ht, 
	    Last_body_write,
	    0,
	    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
  
  // inserimento dell'elemento all'interno del
  // file compresso 
  if (fis==1) 

    { output_token("<", 1, WORD) ; 

    output_token(tag, 
		 strlen(tag),
		 TAG) ; 
    
    Last_body_write=Body_size ; 
    }
  
  xml_pos+=token_len ;
  
  do 
    
    { num_sep=0 ; 
    
    do
      
      { // copia il separatore nell'array 
	sep[num_sep]=separatore ; 
	
	// incrementa il contatore dei separatori 
	++num_sep ; 
	
	// aggiorna il puntatore della posizione 
	++xml_pos ; 

	if (separatore=='/') tag_vuoto=1u;
	
      } while ((separatore != '>') && (num_sep < MAX_SEP) && 
	       ((token_len = get_next_token(xml_code+xml_pos, 
					    " />\t\n", 
					    &separatore, 
					    xml_dim-xml_pos))==0)) ;

    
    // inserimento del simbolo di fine 
    sep[num_sep]='\0' ; 

    if ((tag_vuoto) && (separatore == '>')) 
      
      if (fis == 0) 
	    
	{ hinsert((char *) tag,
		  strlen(tag),
		  TAG,
		  (char *) NULL, 
		  ht, 
		  Last_body_write,
		  EntityRank, 
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ;
	
	++EntityRank ; 
	}

      else
  
	// inserimento della posizione dell'elemento 
	// nel file compresso nella lista contenuta 
	// nella tabella hash 
	hinsert((char *) tag, 
		strlen(tag),
		TAG,
		(char *) NULL, 
		ht, 
		Last_body_write,
		0,
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 	    
	
    // inserimento del separatore nella lista 
    // senza considerare il suo rango 
    if (fis==1)
      
      { output_token(sep, 
		     strlen(sep), 
		     WORD) ; 
      
      // aggiorna il puntatore al file compresso 
      Last_body_write=Body_size ; 
      }
    
    } while ((token_len==0) && (num_sep == MAX_SEP)) ;
  
  // azzera il numero dei separatori 
  num_sep=0 ; 
  
  // controlla l'eventuale presenza di attributi, e 
  // in caso positivo effettua un ciclo per la loro analisi
  if (attr[0] != NULL)  
    
    // per ogni coppia attributo=valore ... 
    for (j=0 ; attr[j]; j+=2)

      { // divide il valore espanso dell'attributo in token 
	// es. 
	// categoria="libri gialli"
	// viene diviso in 2 token, libri e gialli 
	// il ciclo viene ripetuto fino a quando non siano 
	// stati considerati tutti i token del valore 
	// dell'attributo 

	// acquisisce la posizione dell'elemento 
	attr_pos=xml_pos ; 
  
	pos_res=0 ; 

	pos_result=0 ; 

	logic_len=get_next_token((char *) xml_code+attr_pos, 
				 "\'\"",
				 &separatore,
				 xml_dim-attr_pos) ; 
	
	attr_pos+=(logic_len+1) ; 
	
	sprintf(sep, "%c", separatore) ; 

	logic_len=get_next_token((char *) xml_code+attr_pos, 
				 sep,
				 &separatore,
				 xml_dim-attr_pos) ; 
	
	// lettura dell'elemento logico 
	for(k=0 ; k<logic_len; ++k)
	  
	  logic_token[k]=xml_code[attr_pos+k] ;

	logic_token[k]='\0' ; 
	
	for(pos_tok=0, pos_attr=0, pos_res=0 ; ((pos_tok < strlen(logic_token)) && (pos_attr < strlen(attr[j+1]))) ; )

	  if (logic_token[pos_tok] == attr[j+1][pos_attr])
	    
	    { for (i=0, done=0; ((done == 0) && (i<strlen(separatori))); ++i) 

	      if (logic_token[pos_tok] == separatori[i])
		
		done=1 ; 

	    if ((i<strlen(separatori) && (pos_res > 0)))

	      { sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
	      // inserimento della coppia attributo=token_valore nell'indice
	      // tenendo, utilizzando come rango quello del tag all'interno 
	      // del quale e' inserito l'attributo 
	      if (fis==0)  
	      
		hinsert(NTagNAttr, 
			strlen(NTagNAttr), 
			ATTR,
			(char *) NULL,
			ht, 
			Last_body_write, 
			EntityRank,
			((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	      
	      else
		
		hinsert(NTagNAttr, 
			strlen(NTagNAttr), 
			ATTR,
			(char *) NULL,
			ht, 
			Last_body_write, 
			0, 
			((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;
	      
	      result[pos_result]=attr[j+1][pos_attr] ; 

	      // aggiorna i contatori 
	      pos_res=0 ; 

	      ++pos_result ; 
	      
	      ++pos_tok ; 
	      
	      ++pos_attr ; 
	      }

	    else 

	      if (i<strlen(separatori))

		{ result[pos_result]=attr[j+1][pos_attr] ; 

		  result[pos_result+1]='\0' ; 

		  ++pos_result ; 
		  
		  ++pos_tok ; 
		
		  ++pos_attr ; 
		}

	      else 

		{ result_token[pos_res]=attr[j+1][pos_attr]; 

		result_token[pos_res+1]='\0' ; 

		result[pos_result]=attr[j+1][pos_attr] ; 

		result[pos_result+1]='\0' ; 

		++pos_result ; 

		++pos_attr ; 

		++pos_res ; 
		  
		++pos_tok ;  
		}
	    }
	    
	  else
		
	    if (logic_token[pos_tok]=='&')
	      
	      { token_len=get_next_token((char *) (logic_token+pos_tok),
					 ";",
					 sep, 
					 strlen(logic_token)-pos_tok) ;
		
	      if (logic_token[pos_tok+1] == '#')
		
		{ pos_tok+=(token_len+1) ; 

		for (i=0, done=0; ((done==0) && (i<strlen(separatori))); ++i) 
		  
		  if (logic_token[pos_tok] == separatori[i])
		    
		    done=1 ; 
		
		if (i<strlen(separatori))

		  { sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
		  
		  // inserimento della posizione fisica della coppia 
		  // attributo=token_valore nell'indice
		  if (fis==0)  
		    
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    Last_body_write, 
			    EntityRank,
			    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		  
		  else
		    
		    hinsert(NTagNAttr, 
			    strlen(NTagNAttr), 
			    ATTR,
			    (char *) NULL,
			    ht, 
			    Last_body_write, 
			    0, 
			    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;	      

		  // aggiorna i contatori 
		  pos_res=0 ; 
		  
		  ++pos_attr ; 
		  }
		
		else

		  { result_token[pos_res]=attr[j+1][pos_attr] ; 

		  result[pos_res+1]='\0' ; 

		  result[pos_result]=attr[j+1][pos_attr] ; 

		  result[pos_result+1]='\0' ; 

		  ++pos_result ; 

		  ++pos_res ; 

		  ++pos_attr ; 
		  }
		}

	      else

		{ for(i=0 ; i<token_len+1; ++i) 
		  
		  entity_name[i]=logic_token[pos_tok+i] ; 
		
		entity_name[i]='\0' ; 
		
		if (hsearch(entity_name,
			    strlen(entity_name), 
			    NOTHING, 
			    entity))	    
		  
		  { pos_tok+=(token_len+1) ; 

		  for(i=0 ; i<strlen(search->ass_el); ++i)

		    { for(k=0, done=0 ; ((done==0) && (k<strlen(separatori))); ++k)
		      
		      if (separatori[k] == search->ass_el[i])

			    done=1 ; 
		    
		    if ((k<strlen(separatori)) && (pos_res > 0))

			{ sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
			// inserimento della coppia attributo=token_valore nell'indice
			// tenendo, utilizzando come rango quello del tag all'interno 

			// inserimento della posizione fisica della coppia 
			// attributo=token_valore nell'indice
			if (fis==0)  
			  
			  hinsert(NTagNAttr, 
				  strlen(NTagNAttr), 
				  ATTR,
				  (char *) NULL,
				  ht, 
				  Last_body_write, 
				  EntityRank,
				  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
			
			else
			  
			  hinsert(NTagNAttr, 
				  strlen(NTagNAttr), 
				  ATTR,
				  (char *) NULL,
				  ht, 
				  Last_body_write, 
				  0, 
				  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;	 
			
			// aggiorna i contatori 
			pos_res=0 ; 
			}
		  
		    else
		  
		      { result_token[pos_res]=search->ass_el[i] ; 
		      
		      result_token[pos_res+1]='\0' ; 
		  
		      result[pos_result]=search->ass_el[i] ; 
		      
		      result[pos_result+1]='\0' ; 
		  
		      pos_tok+=(token_len+1) ; 

		      ++pos_result ; 
		      
		      ++pos_res ; 
		      }
		    }
		  }

		else
		  
		  if (hsearch(entity_name,
			      strlen(entity_name),
			      NOTHING, 
			      septable)) 
		    
		    { if (pos_res > 0)
		      
		      { sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;
	    
		      if (fis==0)  
			
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				Last_body_write, 
				EntityRank,
				((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
			
		      else
			  
			hinsert(NTagNAttr, 
				strlen(NTagNAttr), 
				ATTR,
				(char *) NULL,
				ht, 
				Last_body_write, 
				0, 
				((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;			  			
		      // aggiorna i contatori 
		      pos_res=0 ; 
		      }
		    
		    pos_tok+=(token_len+1) ; 
		    }
		
		  else
		      
		    { for (i=0; i<token_len+1; ++i) 
		      
		      { result_token[pos_res+i]=logic_token[pos_tok+i] ; 
		      
		      result[pos_result+i]=logic_token[pos_tok+i] ; 
		      }
		    
		    result[pos_result+i]='\0' ; 
		    
		    result_token[pos_res+i]='\0' ; 
		    
		    pos_result+=(token_len+1) ; 

		    pos_res+=(token_len+1) ; 

		    pos_tok+=(token_len+1) ; 
		    }
		}
	      }
  	
	if (pos_res > 0)
	  
	  { sprintf(NTagNAttr, "%s%c%s", attr[j], _SepValAttr, result_token) ;

	  if (fis==0)  
			
	    hinsert(NTagNAttr, 
		    strlen(NTagNAttr), 
		    ATTR,
		    (char *) NULL,
		    ht, 
		    Last_body_write, 
		    EntityRank,
		    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
			
	  else
			
	    hinsert(NTagNAttr, 
		    strlen(NTagNAttr), 
		    ATTR,
		    (char *) NULL,
		    ht, 
		    Last_body_write, 
		    0, 
		    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;		    
	  
	  // aggiorna i contatori 
	  pos_res=0 ; 
	  }

	sprintf(NTagNAttr, "%s%c%c%s%c", attr[j], _SepValAttr, separatore, result, separatore) ;

	if (fis==0)  
			
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  Last_body_write, 
		  EntityRank,
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	
	else
	  
	  hinsert(NTagNAttr, 
		  strlen(NTagNAttr), 
		  ATTR,
		  (char *) NULL,
		  ht, 
		  Last_body_write, 
		  0, 
		  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	
	attr_len = 0 ; 
	
	strcpy(token,"");

	// analizza i delimitatori del valore dell'attributi, 
	// che possono essere sia doppi apici che apici singoli,
	// i valori degli attributi vengono memorizzati nell'indice
	// tenendo conto del simbolo utilizzato come delimitatore 
	token_len=get_next_token(xml_code+xml_pos,
				 "\"\'", 
				 sep, 
				 xml_dim-xml_pos) ; 
	
	// prepara la stringa per la memorizzazione del 
	// valore dell'attributo nel vocabolario, 
	// con gli opportuni delimitatori
	if (sep[0] == _DoppiApici) 
	  
	  sprintf(NTagNAttr, 
		  "%s%c%c%s%c", 
		  attr[j],
		  _SepValAttr, 
		  _DoppiApici,
		  result, 
		  _DoppiApici) ;
	
	else 
	  
	  sprintf(NTagNAttr, 
		  "%s%c%c%s%c", 
		  attr[j], 
		  _SepValAttr, 
		  _Apici, 
		  result,
		  _Apici) ;
	
	// calcola la corrispondenza fra la stringa logica inserita, 
	// che puo' essere derivata dall'espansione di entita' interne,
	// e la stringa fisicamente presente nel sorgent\e XML
      
	// inserimento degli elementi fisicamente presenti
	// nel file
	// es. 
	// categoria = ' libri gialli '
	// in questo caso esattamente questa stringa viene
	// inserita nel vocabolario, per permettere la 
	// decompressione del file 
	
	// legge il token dal file sorgente a partire dal nome dell'attributo 
	// fino al primo delimitatore, il cui valore e' stato accertato 
	// precedentemente 
	token_len1=get_next_token(xml_code+xml_pos,
				  (sep[0] == _DoppiApici) ? "\"" : "\'", 
				  sep, 
				  xml_dim-xml_pos) ;
	
	// legge il token dal file sorgente a partire dal punto precedente 
	// fino alla fine del delimitatore del valore degli attributi 
	token_len2=get_next_token(xml_code+xml_pos+token_len1+1, 
				  (sep[0] == _DoppiApici) ? "\"" : "\'", 
				  sep, 
				  xml_dim-(xml_pos+token_len1+1)) ; 
	
	// calcola l'ampiezza del token fisico trovato 
	// tenedo conto dei due separatori 
	token_len = token_len1 + token_len2 + 2 ;
	
	// confronta il valore fisico con quello logico 
	// considerato precedentemente, 
	if ((fis==1) && (strncmp(xml_code+xml_pos, 
				 NTagNAttr, 
				 token_len) != 0)) 
	  
	  { strncpy((char *) NTagNAttr, 
		    xml_code+xml_pos, 
		    token_len) ; 
	  
	  NTagNAttr[token_len] = '\0' ; 
	  }
	
	// comprime il tag trovato e aggiorna la posizione 
	// nel file compresso 
	if (fis==1) 
	  
	  { output_token(NTagNAttr, strlen(NTagNAttr), ATTR) ;
	  
	  Last_body_write=Body_size ; 
	  }
	
	// aggiornamento del puntatore del file sorgente,
	// tenendo conto della lettura effettuata 
	xml_pos+=token_len ; 
	
	do { num_sep=0;
	
	// scansione degli elementi separatori del file      
	while (((token_len=get_next_token(xml_code+xml_pos, 
					  " />\t\n", 
					  &separatore, 
					  xml_dim-xml_pos)) == 0)
	       && (num_sep < MAX_SEP)) 
	  
	  { // tiene conto del separatore nel 
	    // calcolo della posizione 
	    xml_pos+=1 ; 
	    
	    // copia il separatore trovato 
	    sep[num_sep]=separatore; 
	      
	    // incrementa il numero dei separatori 
	    ++num_sep ; 

	    if (separatore=='/') tag_vuoto=1u; 
	    
	    if (separatore=='>') break ; 
	  }
	
	sep[num_sep]='\0' ; 

	if ((tag_vuoto) && (separatore == '>')) 
	  
	  if (fis == 0) 
	    
	    { hinsert((char *) tag,
		      strlen(tag),
		      TAG,
		      (char *) NULL, 
		      ht, 
		      Last_body_write,
		      EntityRank, 
		      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ;

	    ++EntityRank ; 
	    }

	  else
  
	    // inserimento della posizione dell'elemento 
	    // nel file compresso nella lista contenuta 
	    // nella tabella hash 
	    hinsert((char *) tag, 
		    strlen(tag),
		    TAG,
		    (char *) NULL, 
		    ht, 
		    Last_body_write,
		    0,
		    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 	    
	
	  
	// inserimento del separatore nella tabella Hash
	// senza considerare il suo rango 
	if (fis==1) 
	  
	  { output_token(sep, 
			 strlen(sep), 
			 WORD) ; 
	    
	  Last_body_write=Body_size ; 
	  }
	} while ((separatore!='>') && (token_len==0)) ;
      }

  return ; 
}
/*******************************************************************
     	     Gestore della codifica della fine del Tag
*******************************************************************/
void endcod(void *data,
	    const char *el)
{ // token individuato dalla funzione get_next_token 
  char token[MAX_TAG_NAME]="\0" ;
  
  // stringa utilizzata per memorizzare i separatori nella
  // tabella Hash 
  char sep[MAX_SEP]="\0" ; 
  
  // separatore trovato dalla funzione get_next_token 
  char separatore='\0' ; 

  // lunghezza del token individuato dalla funzione get_next_token 
  int token_len=0 ; 
  
  // numero dei separatori trovati 
  int num_sep=0 ; 
  
  // variabile contatore
  int k=0 ; 
  
  // numero dei bytes letti dal buffer di sistema 
  int count=0 ; 
  
  // decrementa il numero degli elementi aperti 
  // per determinare se siamo o meno all'interno 
  // di un tag XML
  --num_tag ; 
  
  // svuota l'eventuale buffer presente in memoria
  // e ne considera il token come una componente logica 
  if (text_in_buffer(&textbuffer))
    
    { // estrae l'elemento dal buffer di memoria 
      count=get_text_in_buffer(&textbuffer, 
			       token) ; 
      
      token[count]='\0' ; 
      
      // trasforma la stringa in minuscola 
      undercase(token, count) ; 
      
      // inserimento della posizione dell'elemento 
      // all'interno del file compresso 
      if (fis==0)
	
	{ hinsert((char *) token, 
		  count,
		  WORD,
		  (char *) NULL, 
		  ht, 
		  Last_body_write,
		  EntityRank, 
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	
	++EntityRank ; 
	}
      
      else
	
	hinsert((char *) token, 
		count,
		WORD,
		(char *) NULL, 
		ht, 
		Last_body_write,
		0, 
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
    }
  
  // aggiornamento della posizione 
  // all'interno del file compresso 
  if (fis==1) 

    Last_body_write=Body_size ; 

  Last_fis=fis ; 
  
  // determina se quanto contenuto nella posizione 
  // fisica dell'elemento corrisponde con la posizione
  // logica. Il token trovato viene eventualmente 
  // compresso 
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ;
  
  if ((fis==0) && (change==1)) 
    
    // annulla il rango dell'entita' 
    EntityRank=1 ; 

  if (fis==0) 

    { hinsert((char *) el,
	      strlen(el),
	      TAG,
	      (char *) NULL, 
	      ht, 
	      Last_body_write,
	      EntityRank, 
	      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    ++EntityRank ; 
    }

  // controlla se siamo nel caso di chiusura dell'elemento 
  // congiunta all'apertura, esempio
  // <PROVA />
  // in questo caso il simbolo di chiusura gia' e' stato codificato,
  // altrimenti codifica gli elementi facenti parte del tag di 
  // chiusura 
  if ((xml_code[xml_pos] == '<') && (xml_code[xml_pos+1] == '/'))
    
    { token_len=get_next_token(xml_code+xml_pos, 
			       " \t\n>",
			       &separatore, 
			       xml_dim-xml_pos
			       ) ; 
    
    if (token_len > 0) 
      
      { // copia il token trovato all'interno del file 
	// sorgente 
	for (k=0; k<token_len-2; ++k) 
	  
	  token[k] = xml_code[xml_pos+k+2] ; 
	
	token[k] = '\0' ;
	
	// controlla se il tag chiuso all'interno del file
	// sorgente e lo stesso token che e' stato passato
	// al gestore 
	if (strcmp(el, 
		   token)== 0)
	  
	  { if (fis==1) 
	    
	    { output_token("<", 
			   strlen("<"), 
			   WORD) ;
	    
	    output_token("/", 
			 strlen("/"), 
			 WORD) ;

	    // comprime l'elemento 
	    output_token((char *) el, 
			 strlen(el), 
			 TAG) ; 
	    
	    // aggiorna il puntatore all'interno del file
	    // compresso 
	    Last_body_write=Body_size ; 
	    }
	  
	  // aggiorna il puntatore all'interno dello stream logico 
	  xml_pos+=token_len ; 
	  }
	
	else goto uscita ; 
      }
    
    // in questo caso tutti gli elementi sono stati analizzati
    // e quindi si esce dalla gestione dell'elemento
    else goto uscita ; 
    
    do { num_sep=0 ; 
    
    do {
      // scrive il separatore trovato all'interno della stringa prevista
      sep[num_sep]=separatore; 
      
      // incrementa il numero dei separatori trovati 
      ++num_sep ; 
      
      // incrementa la posizione all'interno dello stream logico 
      xml_pos+=1 ; 
      
      // cicla fina a quando non si e' raggiunta la fine 
      // della chiusura del tag 
    } while ((separatore != '>') 
	     && 
	     (num_sep < MAX_SEP) && 
	     (token_len=get_next_token(xml_code+xml_pos, 
				       " \t\n>",
				       &separatore, 
				       xml_dim-xml_pos)==0)) ; 
    
    sep[num_sep]='\0' ; 

    if (fis==1) 
      
      { if (separatore == '>')

	hinsert((char *) el,
		strlen(el),
		TAG,
		(char *) NULL, 
		ht, 
		Last_body_write,
		EntityRank, 
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 	

	// comprime l'elemento separatore 
	output_token(sep, 
		     strlen(sep), 
		     WORD) ;
	
	// aggiorna la posizione all'interno del file compresso 
	Last_body_write=Body_size ; 
      }
    
    } while ((token_len==0) && (separatore != '>')) ; 
    }
  
  uscita : 

  return;
}
/******************************************************************** 
	       Gestore della codifica degli elementi di testo
*********************************************************************/
void 
textcod(void *data, 
	const char *t, 
	int len)
{ // variabile utilizzata come contatore in un ciclo  
  int k=0 ; 
  
  // numero degli elementi letti dal buffer 
  int count=0 ;

  // numero di bytes letti nel testo 
  int tagcount=0 ;

  // lunghezza del token trovato dalla funzione get_next_token 
  int token_len=0 ;

  // flag per determinare se il testo debba essere bufferizzato o 
  // meno 
  unsigned 
    short 
    int separa=0 ;
  
  // variabile usata per contenere il valore del puntatore
  // al file compresso 
  int Last=0 ; 
  
  // numero dei separatori trovati 
  int num_sep=0 ; 
  
  // stringa per contenere il token individuato dalla funzione 
  // get_next_token 
  char token[MAX_TAG_NAME]="\0" ; 
  
  // stringa per la memorizzazione del separatore all'interno della
  // tabella Hash 
  char sep[MAX_SEP]="\0" ;
  
  // separatore trovato dalla funzione get_next_token 
  char separatore='\0' ;
  
  // memorizza il puntatore al file compresso
  // per utilizzarlo successivamente 
  Last=Body_size ; 
  
  Last_fis=fis ; 

  // determina se quanto contenuto nella posizione 
  // fisica dell'elemento corrisponde con la posizione
  // logica, ed eventualmente comprime il token 
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ;  
  
  // determina se il testo rappresenta l'espansione di una 
  // entita' che e' stata definita come separatore nel file 
  // di configurazione 
  if ((fis==0) && 
       
      (hsearch(token, 
	       strlen(token), 
	       NOTHING, 
	       septable)))
    
    separa=1 ; 
  
  do { // cicla per gestire il testo 
    
    do { // azzera il numero dei separatori 
         num_sep=0 ; 
	 
	 // finche' si trovano dei separatori all'interno del file 
	 // si cicla all'interno del while
	 while((tagcount < len) && 
	       (num_sep < MAX_SEP) &&
	       ((token_len=get_next_token((char *) t+tagcount, 
					  separatori,
					  &separatore,
					  len-tagcount)) == 0))
	   
	   { // determina se esiste del testo bufferizzato 
	     // e in questo caso, avendo trovato un separatore nel 
	     // file di testo, il testo bufferizzato viene estratto
	     // e viene memorizzata la posizione fisica all'interno del 
	     // file compresso 
	     if (text_in_buffer(&textbuffer)) 
	       
	       { // estrae il testo contenuto nel file compresso 
		 count=get_text_in_buffer(&textbuffer, 
					  token) ; 
		 
		 token[count]='\0' ; 
		 
		 // trasforma la stringa in minuscolo 
		 undercase(token, count) ; 

		 // inserimento della posizione fisica all'interno della lista
		 // contenuta nella posizione della tabella Hash 
		 if (Last_fis==0)
		   
		   { hinsert((char *) token, 
			     count, 
			     WORD,
			     (char *) NULL, 
			     ht, 
			     Last_body_write,
			     EntityRank, 
			     ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		   
		   ++EntityRank ; 
		   }
		 
		 else
		   
		   hinsert((char *) token, 
			   count, 
			   WORD,
			   (char *) NULL, 
			   ht, 
			   Last_body_write,
			   0, 
			   ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	       }
	     
	     // aggiorna il puntatore al file compresso
	     if (fis==1) Last_body_write=Last ;  
	     
	     // azzera il contatore delle espansioni dei ranghi 
	     // nell'entita' 
	     if ((fis==0) && (change==1)) 
	       
	       EntityRank=1 ; 

	     // aggiorna i puntatori agli stream logici e fisici 
	     tagcount+=1 ; 
	 
	     xml_pos+=1 ; 
	 
	     // copia il separatore 
	     sep[num_sep]=separatore ; 
	 
	     // incrementa il numero dei separatori 
	     ++num_sep ; 
	   }
	 
	 if ((fis==1) && (num_sep > 0))  
	   
	   { sep[num_sep]='\0' ; 
	   
	   // comprime il separatore 
	   output_token(sep, 
			strlen(sep),
			WORD) ; 
	   
	   // aggiorna il puntatore nel file compresso 
	   Last_body_write=Body_size ; 
	   }
    
    } while((token_len==0) && (tagcount < len)) ;  
  
    // in questo caso tutti gli elementi del testo sono 
    // stati considerati, si esce dal ciclo di gestione
    // degli elementi 
    if (tagcount >= len) break ; 
  
    // se l'entita' e' un separatore allora il testo bufferizzato
    // viene estratto 
    if ((text_in_buffer(&textbuffer)) && (separa))
      
      { // estrae il testo contenuto nel file compresso 
	count=get_text_in_buffer(&textbuffer, 
				 token) ; 
	
	token[count]='\0' ; 

	// trasforma la stringa in minuscolo 
	undercase(token, count) ; 

	// inserimento della posizione fisica all'interno della lista
	// contenuta nella posizione della tabella Hash 
	if (Last_fis==0)
	  
	  { hinsert((char *) token, 
		    count, 
		    WORD,
		    (char *) NULL, 
		    ht, 
		    Last_body_write,
		    EntityRank, 
		    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	  
	  // incrementa il rango nell'espansione dell'entita'
	  ++EntityRank ; 
	  }
	
	else
	  
	  hinsert((char *) token, 
		  count, 
		  WORD,
		  (char *) NULL, 
		  ht, 
		  Last_body_write,
		  0, 
		  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	
	if ((fis==0) && (change==1)) 
	  
	  EntityRank=1 ; 
      }
    
    // l'ultimo elemento del testo viene bufferizzato 
    if ((token_len == len-tagcount) && (separa==0))    
      
      { // copia il token trovato 
	for(k=0; k<token_len; ++k) 
	  
	  token[k]=t[tagcount+k] ; 
	
	token[k]='\0' ; 
	
	// inserisce l'elemento all'interno del buffer 
	insert_buffer(&textbuffer, 
		      token,
		      token_len) ; 
	
	if (fis==1) 
	  
	  // comprime il token, senza aggiornare 
	  // il puntatore al file compresso 
	  output_token(token, 
		       token_len,
		       WORD) ; 
	
	// aggiorna il puntatore al file compresso 
	xml_pos += token_len ; 

	Last_fis=fis ; 
	
	return; 
      }
    
    else 
      
      // in questo caso l'elemento e' una entita' 
      // definita come separatore all'interno del file,
      // il token viene compresso e il puntatore al file
      // compresso aggiornato 
      if ((token_len == len-tagcount) && (separa)) 
	
	{ // copia il token all'interno del file 
	  for(k=0; k<token_len; ++k) 
	    
	    token[k]=t[tagcount+k] ; 
	  
	  token[k]='\0' ; 
	  
	  if (fis==1) 
	    
	    { // comprime il token
	      output_token(token, 
			   token_len,
			   WORD) ; 
	      
	      // aggiorna il puntatore al file compresso 
	      Last_body_write=Body_size ; 
	    }
	  
	  // aggiorna il puntatore agli stream fisico e logico
	  xml_pos += token_len ; 

	  Last_fis=fis ; 
	  
	  return; 
	}
    
      else
	
	// siamo in un caso non contemplato nel codice precedente,
	// il testo viene quindi estratto dal buffer e concatenato
	// al token trovato dal gestore 
	if (text_in_buffer(&textbuffer))
	  
	  { // estrae il testo dal buffer di memoria ...
	    count=get_text_in_buffer(&textbuffer, 
				     token) ; 
	    
	    token[count]='\0' ; 
	  }
    
	else count = 0 ; 
    
    // ... e vi aggiunge il resto del token da analizzare 
    for(k=0; k<token_len; ++k) 
      
      token[k+count]=t[tagcount+k] ; 
    
    token[k+count]='\0' ; 
    
    if (fis==1) 
      
      // comprime il token trovato dal gestore
      output_token(token+count, 
		   token_len,
		   WORD) ; 
    
    undercase(token, token_len+count) ; 


    // inserimento della posizione fisica del file 
    // compresso all'interno della lista contenuta
    // nella posizione della tabella hash 
    if (fis==1) 
      
      hinsert((char *) token,
	      token_len+count,
	      WORD,
	      (char *) NULL,
	      ht,
	      Last_body_write,
	      0, 
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ;
    
    else
      
      { hinsert((char *) token,
		token_len+count,
		WORD,
		(char *) NULL,
		ht,
		Last_body_write,
		EntityRank, 
		((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
      
      // incrementa il rango dell'entita' 
      ++EntityRank ; 
      }
    
    // aggiorna i puntatori agli stream fisico e logico 
    tagcount+=token_len ; 
    
    xml_pos+=token_len ; 
    
    // aggiornamento del puntatore al file compresso 
    if (fis==1) Last_body_write=Body_size;

  } while (tagcount < len) ; 

  Last_fis=fis ; 

  return ; 
}
/*******************************************************************
       Gestore della codifica dell'inizio di una sezione CDATA
 *******************************************************************/
void 
cdstartcod(void *data) 
{ // token per l'apertura della sezione CDATA 
  const char 
    apertura[] = "<![CDATA["; 

  // token ottenuto dalla funzione get_next_token e dallo
  // svuotamento del buffer 
  char token[MAX_TAG_NAME]="\0" ;
  
  // separatore trovato dalla funzione get_next_token 
  char separatore='\0' ;
  
  // numero di bytes letti dal buffer 
  int count=0 ;  
  
  // svuota l'eventuale buffer presente in memoria
  // e ne considera il token come una componente logica 
  if (text_in_buffer(&textbuffer))
    
    { // estrae il testo dal buffer 
      count=get_text_in_buffer(&textbuffer, 
			       token) ; 
      
      token[count]='\0' ; 
      
      // trasforma il testo in minuscolo 
      undercase(token, count) ; 
      
      // inserisce la posizione fisica all'interno della 
      // lista contenuta nella posizione della tabella hash 
      if (fis==1) 
	
	hinsert((char *) token, 
		count,
		WORD,
		(char *) NULL, 
		ht, 
		Last_body_write,
		0,
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
      
      else
	
	{ hinsert((char *) token, 
		  count,
		  WORD,
		  (char *) NULL, 
		  ht, 
		  Last_body_write,
		  EntityRank,
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	
	// incrementa il rango per l'espansione dell'entita'
	++EntityRank ; 
	}
    }
  
  // aggiorna il puntatore al file compresso 
  if (fis==1) Last_body_write=Body_size ; 

  Last_fis=fis ; 
  
  // determina se quanto contenuto nella posizione 
  // fisica dell'elemento corrisponde con la posizione
  // logica, ed eventualmente comprime il token trovato
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ;  
  
  if ((fis==0) && (change==1)) 
    
    // azzera i ranghi all'interno dell'espansione dell'entita' 
    EntityRank=1 ; 
  
  // inserimento della posizione fisica all'interno della lista 
  // contenuta nella posizione della tabella hash relativa 
  // al token dell'apertura 
  if (fis==1) 
    
    hinsert((char *) apertura, 
	    strlen(apertura), 
	    TAG,
	    (char *) NULL, 
	    ht, 
	    Last_body_write,
	    0,
	    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
  
  else
   
    { hinsert((char *) apertura, 
	      strlen(apertura), 
	      TAG,
	      (char *) NULL, 
	      ht, 
	      Last_body_write,
	      EntityRank, 
	      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    // incrementa il rango all'interno dell'entita'
    ++EntityRank ; 
    }
  
  // memorizza il byte degli elementi nella struttura dati 
  // dell'indice
  if (fis==1) 
    
    { // comprime il token di apertura della sezione CDATA
      output_token((char *) apertura, 
		   strlen(apertura),
		   TAG) ; 
      
      // aggiornamento della posizione nel file compresso 
      Last_body_write=Body_size ; 
    }
  
  else
    
    // pone a on il flag di una sezione CDATA che rappresenta
    // l'espansione di una entita'. Questo flag sara' necessario
    // per distinguere il caso in cui all'interno della sezione
    // CDATA ci sia il carattere ampersand, per non considerare
    // l'espansione dell'eventuale entita' corrispondente
    // pone a 1 il flag di una sezione CDATA che rappresenta
    // l'espansione di una entita' 
    Sez_Cdata_exp_ent=1;
  
  // aggiorna il puntatore allo stream logico 
  xml_pos+=strlen(apertura) ; 
  
  // pone il flag di della sezione CDATA 
  // ad 1 
  Sez_Cdata=1 ;
  
  return ;
}
/*******************************************************************
	 Gestore della codifica della fine di una sezione CDATA
*******************************************************************/
void 
cdendcod(void *data) 
{ // token per l'apertura della sezione CDATA 
  const 
    char apertura[] = "<![CDATA["; 
  
  // token per la chiusura di una sezione CDATA
  const 
    char chiusura[] = "]]>" ;

  // token ottenuto dalla funzione get_next_token e dallo
  // svuotamento del buffer 
  char token[MAX_TAG_NAME]="\0" ; 
  
  // numero di bytes letti dal buffer di testo 
  int count=0 ;
  
  // svuota l'eventuale buffer presente in memoria
  // e ne considera il token come una componente logica 
  if (text_in_buffer(&textbuffer))
    
    { // estrae il testo dal buffer 
      count=get_text_in_buffer(&textbuffer, 
			       token) ; 
      
      token[count]='\0' ; 
      
      // trasforma il testo in minuscolo 
      undercase(token, count) ; 

      // inserisce la posizione fisica nel file compresso
      // all'interno della lista contenuta nell'elemento 
      // della tabella hash 
      if (fis==1) 
	
	hinsert((char *) token, 
		count,
		WORD,
		(char *) NULL, 
		ht, 
		Last_body_write,
		0,
		((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
      
      else
	
	{ hinsert((char *) token, 
		  count,
		  WORD,
		  (char *) NULL, 
		  ht, 
		  Last_body_write,
		  EntityRank,
		  ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 

	// incrementa il rango all'interno dell'entita' 
	++EntityRank ; 
	}
    }
  
  // aggiornamento del puntatore al file compresso 
  if (fis==1) Last_body_write=Body_size ; 
  
  Last_fis=fis ; 

  // determina se quanto contenuto nella posizione 
  // fisica dell'elemento corrisponde con la posizione
  // logica
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ;  
  
  if (fis==1)
    
    { hinsert((char *) apertura, 
	      strlen(apertura), 
	      TAG,
	      (char *) NULL, 
	      ht, 
	      Last_body_write,
	      0,
	      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
    
    // comprime il tag di chiusura della sezione CDATA
    output_token((char *) chiusura, 
		 strlen(chiusura),
		 WORD) ; 
      
    // aggiorna il puntatore al file compresso 
    Last_body_write=Body_size ; 
    }
  
  else

    { hinsert((char *) apertura, 
	      strlen(apertura), 
	      TAG, 
	      (char *) NULL, 
	      ht, 
	      Last_body_write,
	      EntityRank,
	      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
    
    ++EntityRank; 
    }

  // pone il flag della sezione CDATA a 0  
  Sez_Cdata=0 ; 
  
  // aggiorna il puntatore 
  xml_pos+=strlen(chiusura) ; 
  
  // pone eventualmente a 0 il flag di sezione CDATA 
  // ottenuta dall'espansione di una entita' 
  if ((fis==0) && (Sez_Cdata_exp_ent==1)) 
    
    Sez_Cdata_exp_ent=0; 
  
  return ; 
}
/*******************************************************************
		Gestione di tutti gli altri elementi 
*******************************************************************/
void defacod(void *data,
	     const XML_Char *s,
	     int len) 
{ // variabile contatore 
  int k=0 ; 
  
  // numero di bytes letti dal buffer di testo 
  int count=0 ;
  
  // lunghezza dei token 
  int token_len=0 ;
  
  // contatore per la lettura dell'elemento logico 
  int tagcount=0 ;
  
  // variabile usata per contenere il valore del puntatore
  // al file compresso 
  int Last=0 ; 
  
  // e' il numero dei separatori trovati nell'array 
  int num_sep=0 ; 
  
  // token letto dal buffer di testo e dalla 
  // funzione get_next_token  
  char token[MAX_TAG_NAME]="\0" ; 
  
  // elemento che contiene il tag da scrivere nel vocabolario
  char tag[MAX_TAG_NAME]="\0" ; 
  
  // stringa utilizzata per memorizzare il separatore nella 
  // tabella hash 
  char sep[MAX_SEP]="\0" ;
  
  // separatore trovato dalle funzioni get_next_token 
  char separatore='\0' ;
  
  // memorizza la posizione all'interno del file compresso 
  Last=Body_size ; 
  
  Last_fis=fis ; 

  // determina se quanto contenuto nella posizione
  // fisica dell'elemento corrisponde con la posizione
  // logica
  fis=phy_corr(token, 
	       MAX_TAG_NAME, 
	       0) ;  
  
  // controlla se si tratta di una entita' generale esterna,
  // che non e' un separatore, e che siamo all'interno del 
  // testo
  if ((fis==0) && 
      (num_tag>0) &&  
      (strncmp(s, 
	       token, 
	       len) == 0) && 
      (!hsearch(token, 
		len, 
		NOTHING, 
		septable)))
    
    { // aggiorna l'elemento per consentire un corretto
      // comportamento, non e' l'espansione di una entita'
      // da espandere
      Last_fis=1 ; 
      
      fis=1 ; 

      // in questo caso l'entita' viene bufferizzata, 
      // senza aggiornare il puntatore al file compresso 
      insert_buffer(&textbuffer,
		    token,
		    len) ; 
		    
      
      // aggiorna il puntatore allo stream logico dell'elemento 
      xml_pos+=len ; 
      
      return ; 
    }
  
  else 

    // si tratta di una entita' esterna che non e' una separatore, che a
    // sua volta e' contenuta all'interno di una entita' parametrica interna 
    if ((fis==0) && 
	(num_tag>0) &&  
	(!strncmp(s, 
		  token, 
		  len) == 0) && 
	(!hsearch(token, 
		  len, 
		  NOTHING, 
		  septable)))
 
      { Last_fis=fis ;

      // in questo caso l'entita' viene bufferizzata, 
      // senza aggiornare il puntatore al file compresso 
      insert_buffer(&textbuffer,
		    (char *) s,
		    len) ; 
      
      // aggiorna il puntatore allo stream logico dell'elemento 
      xml_pos+=len ; 
      
      return ; 
      }

  else
    
    // si tratta di una entita' esterna e' una separatore, che a
    // sua volta e' contenuta all'interno di una entita' parametrica interna 
    if ((fis==0) && 
	(num_tag>0) &&  
	(!strncmp(s, 
		  token, 
		  len) == 0) && 
	(hsearch(token, 
		 len, 
		 NOTHING, 
		 septable)))
      
      {  // legge il testo dal buffer 
	count=get_text_in_buffer(&textbuffer,
				 tag) ; 
	
	tag[count]='\0' ; 
	
	// trasforma la stringa in minore 
	undercase(tag, count) ; 

	// inserisce la posizione nella lista associata all'elemento
	// della tabella hash 
	if (Last_fis==1) 

	  hinsert((char *) tag,
		  count,
		  WORD,
		  (char *) NULL,
		  ht, 
		  Last_body_write,
		  0,
		  ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	
	else 
	  
	  { hinsert((char *) tag,
		    count,
		    WORD,
		    (char *) NULL,
		    ht, 
		    Last_body_write,
		    EntityRank,
		    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	  
	  // incrementa il rango all'interno dell'espansione dell'entita' 
	  ++EntityRank ; 
	  }
	
	if ((fis==0) && (change==1)) 
	  
	  EntityRank=1 ; 
	
	// aggiorna il puntatore allo stream logico 
	xml_pos+=len ;
      }

    else
      
      // in questo caso si tratta di un'entita' generale esterna
      // che e' un separatore, si deve quindi svuotare l'eventuale 
      // buffer 
      if ((fis==0) && 
	  (num_tag>0) && 
	  (strncmp(s, 
		   token, 
		   len) == 0) &&
	  text_in_buffer(&textbuffer))
	
	{ // legge il testo dal buffer 
	  count=get_text_in_buffer(&textbuffer,
				   tag) ; 
	  
	  tag[count]='\0' ; 
	  
	  // trasforma la stringa in minore 
	  undercase(tag, count) ; 
	  
	  // inserisce la posizione nella lista associata all'elemento
	  // della tabella hash 
	  if (Last_fis==1) 
	    
	    hinsert((char *) tag,
		    count,
		    WORD,
		    (char *) NULL,
		    ht, 
		    Last_body_write,
		    0,
		    ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
	  
	  else 
	    
	    { hinsert((char *) tag,
		      count,
		      WORD,
		      (char *) NULL,
		      ht, 
		      Last_body_write,
		      EntityRank,
		      ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
	    
	    // incrementa il rango all'interno dell'espansione dell'entita' 
	    ++EntityRank ; 
	    }
	  
	  if ((fis==0) && (change==1)) 
	    
	    EntityRank=1 ; 
	  
	  // aggiorna il puntatore al file compresso 
	  Last_body_write=Last ; 
	
	  // aggiorna il puntatore allo stream logico 
	  xml_pos+=len ;
	}
  
      else 
	
	{ // si tratta di elementi standard da tokenizzare
	  // non facenti parte del testo xml 
	  while(tagcount < len) {
	    
	    do { 
	      
	      // azzera il numero dei separatori trovati 
	      num_sep=0 ;
	      
	      // cicla fino a quando incontra dei separatori 
	      while((tagcount < len) &&
		    (num_sep < MAX_SEP) && 
		    ((token_len = get_next_token((char *) s+tagcount, 
						 " \t\n", 
						 &separatore, 
						 len-tagcount)) == 0))
		
		{ if (text_in_buffer(&textbuffer))
		  
		  { // estrae il testo dal buffer in memoria 
		    count=get_text_in_buffer(&textbuffer, 
					   token) ; 
		    
		    token[count]='\0' ; 
		    
		    // trasforma la stringa tutta in minuscolo 
		    undercase(token, len) ;
		  
		    // inserisce la posizione nel file compresso nella lista
		    // associata all'elemento della tabella hash
		    if (Last_fis==1) 
		      
		      hinsert((char *) token,
			      count,
			      WORD,
			      (char *) NULL,
			      ht, 
			      Last_body_write, 
			      0,
			      ((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
		    
		    else 
		      
		      { hinsert((char *) token,
				count,
				WORD,
				(char *) NULL,
				ht,
				Last_body_write,
				EntityRank, 
				((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		      
		      // incrementa il rango dell'espansione dell'entita'
		      ++EntityRank ; 
		      }
		    
		    if ((fis==0) && (change==1)) 
		      
		      EntityRank=1 ; 
		    
		    // aggiorna il puntatore al file compresso 
		    Last_body_write=Last ; 
		  }
		
		// aggiorna i puntatori allo stream logico e fisico
		// degli elementi 
		++tagcount ;
		
		++xml_pos ; 
		
		// copia il separatore trovato all'interno del vettore
		sep[num_sep]=separatore ; 
		
		// incrementa il numero dei separatori trovati 
		++num_sep ; 
	      }
	      
	      if ((fis==1) && (num_sep > 0)) 
		
		{ // scrive il carattere terminatore 
		  sep[num_sep]='\0' ; 
		  
		  // comprime l'eventuale separatore trovato 
		  output_token(sep, strlen(sep), WORD) ; 
		  
		  // aggiorna il puntatore al file compresso 
		  Last_body_write=Body_size ; 
	      }
	      
	    } while ((token_len==0) && (tagcount < len)) ; 
	    
	    // in questo caso tutti gli elementi sono stati
	    // analizzati, si esce dal ciclo di gestione 
	    if (tagcount >= len) break ; 
	    
	    if (text_in_buffer(&textbuffer))
	      
	      { // estrae il testo dal buffer in memoria 
		count=get_text_in_buffer(&textbuffer, 
				       token) ; 
		
		token[count]='\0' ; 
		
		undercase(token, count) ; 
		
		// inserisce la posizione nel file compresso nella lista
		// associata all'elemento della tabella hash
		if (Last_fis==1) 
		  
		hinsert((char *) token,
			count,
			WORD,
			(char *) NULL,
			ht, 
			Last_body_write, 
			0,
			((0x00) | _INSERT_PHYSICAL_OCCURRENCE)) ; 
		
		else 
		
		  { hinsert((char *) token,
			    count,
			    WORD,
			    (char *) NULL,
			    ht,
			    Last_body_write,
			    EntityRank, 
			    ((0x00) | _INSERT_PHYSIC_ESCAPE)) ; 
		  
		  // incrementa il rango dell'espansione dell'entita'
		  ++EntityRank ; 
		}
		
		if ((fis==0) && (change==1)) 
		  
		  EntityRank=1 ; 
		
		// aggiorna il puntatore al file compresso 
		Last_body_write=Last ; 
	      }
	    
	    // copia il token trovato nella stringa preposta 
	    for(k=0;k<token_len;++k) 
	      
	      token[k]=s[tagcount+k] ; 
	    
	  token[k]='\0' ;
	  
	  // memorizza il token all'interno del dizionario 
	  // fisico 
	  if (fis==1) 
	    
	    { // comprime il token trovato 
	      output_token(token, 
			   token_len, 
			   WORD) ; 
	      
	      // aggiorna il puntatore al file compresso
	      Last_body_write=Body_size ; 
	    }
	  
	  // aggiorna i puntatori dello stream logico e fisico 
	  tagcount += token_len ; 
	  
	  xml_pos += token_len ; 
	  }
	}
  return ; 
}

