/********************************************************************
		      xcde_build_ind.c :
    contains functions main, output_IL and compute_optimal_k
	      Xml Compressor Decompressor search Engine
	               Building Program
	            By Andrea Mastroianni 
		      Universita' di Pisa 
		    mastroi@cli.di.unipi.it
		   version 04 february, 2002
********************************************************************/
#include"xcde_consts.h"
#include"xml_ind.h" 
/*******************************************************************
                   DECLARING GLOBAL VARIABLES
 *******************************************************************/

// FILES POINTERS
FILE *inputFile ; 

FILE *configFile ; 

FILE *dictsFile[NUMBER_DICT] ; 

FILE *bodyFile ;

FILE *headerFile ; 

FILE *IL_File ; 

FILE *tagstructFile ; 

FILE *debugPhysicView ; 

FILE *debugIndexFile ; 

FILE *debugStatsFile ; 

// FILES' NAMES POINTERS

char *inputFilename=NULL ; 

char *dictionaryFilename[NUMBER_DICT] ; 

char *headerFilename=NULL ; 

char *bodyFilename=NULL ; 

char *IL_Filename=NULL ; 

char *tagstructFilename=NULL ; 

char *debugPhysicFilename=NULL ; 

char *debugStatsFilename=NULL ; 

char *debugIndexFilename=NULL ; 

char *configFilename=NULL ;

int inputFilesize=0 ; 

char expat_parsing_buffer[XCDE_EXPAT_PARSING_BUFFER_SIZE] ; 

char zlib_decompress_buffer[XCDE_COMPRESS_BLOCK_SIZE] ; 

char zlib_compress_buffer[2*XCDE_COMPRESS_BLOCK_SIZE] ; 

int pointer_decompress_buffer=0 ; 

unsigned 
char expat_CDATA_section_flag=0 ; 

unsigned
char expat_DTD_flag=0u ; 

unsigned
char expat_CDATA_expantion_flag=0 ; 

unsigned
char verbosing_flag=0u ; 

unsigned 
char proximity_flag=1u ; 

unsigned
char tagstruct_flag=0u ; 

unsigned
char different_configfile_flag=0u ; 

int proximity_counter=0 ; 

int element_displacement=0 ; 

int number_tokens=0 ; 

int last_body_position_written=0 ; 

int bodyFileSize=0 ; 

int dictionaryFileSize=0 ; 

int expat_number_tag_opened=0 ; 

// matrice necessaria per la divisione del dizionario per 
// i tag, gli attributi e le parole
// elem[0][0] contiene il numero dei TAG di ampiezza 1
// elem[1][0] contiene il numero dei TAG di ampiezza 2
// elem[2][0] contiene il numero dei TAG di ampiezza 3 
// ...
// elem[0][1] contiene il numero degli ATTR di ampiezza 1
// elem[1][1] contiene il numero degli ATTR di ampiezza 2
// elem[2][1] contiene il numero degli ATTR di ampiezza 3
// ...
// elem[0][2] contiene il numero delle WORD di ampiezza 1
// elem[1][2] contiene il numero delle WORD di ampiezza 2
// elem[2][2] contiene il numero delle WORD di ampiezza 3
int dict_elem[HUFF_MAX_LEVEL][NUMBER_DICT] ; 

// hash table which contains the tokens found during the parsing
HashTable ht ; 

// hash table which contains general internal entities 
HashTable expat_general_declared_entity ;

// hash table which contains the separators
HashTable expat_separators_table ; 

// Huffman tree build 
Hashptr *Huffman_tree=NULL ;
  
// data structure used by Expat 
XML_Parser parser ;

char *expat_source_pointer=NULL ; 

// variables used to traduce the physical text into the logical view
char *xml_code=NULL ;

long xml_dimension=0 ;

long xml_position=0 ; 

// last physical position where an entity has been expanded ; 
long last_expandend_position=-1 ; 

// flag which indicates if the position parsed has changed 
unsigned 
char changed_position=0 ;

// flag which indicates if there is a corrispondence between
// the physical view and the logical one 
unsigned 
char physical_corrispondence=0 ;

// rank needed to compute proximity  
int elementRank=1 ; 

// used by the stat function
struct stat sbuf ;

Textbuffer textbuffer ;

char separators[MAX_SEP]=" <>?!,.;:()[]{}\t\n\"" ;

char attribute_separators[MAX_SEP]=" <>?!,.;:()[]{}\t\n\"" ;

uchar *body_pointers_cmp_buffer=NULL ; 

uchar *body_pcmp_point=NULL ; 

int body_pointers_cmp_buffer_dimension=2*K ; 

int number_body_points=1 ; 

int body_bit_offset=0 ; 

uchar **IL_pointers_buff=NULL ; 

int IL_pointers_buff_length=0 ; 

int number_IL_table_pointer=0 ; 

int diff_position=0 ; 

int new_diff_position=0 ; 

int new_body_pointers_point=0 ; 

int len_body_without_lzip=0 ; 

int number_tagstruct_intervals=0 ; 

void compute_optimal_k(unsigned int *k, 
		       indexList ByteList,
		       unsigned int numByteList,
		       indexList ProxList,
		       unsigned char Prox,
		       unsigned short int type) ;

/*******************************************************************
                             FUNCTIONS     
 *******************************************************************/

int 
main(int argc, 
     char *argv[])
{ // counters 
  int j=0 ; 
  int k=0 ;
  int i=0 ;

  // variable used to check functions results
  int result=0 ; 

  // used to construct the Huffman code 
  int offsetcw[5] ;
  int firstcw[5] ;
  int count_depth[5] ;
  
  // level in the Huffman tree 
  int current_level=0 ; 

  // used in the Huffman code 
  int count=0 ;

  // used to write integer in the header file 
  int temp=0 ;

  // variabile utilizzata per il calcolo della profondita' massima
  // dell'albero di Huffman
  int max_length=0 ;

  int number_levels=0 ; 

  int len=0 ;

  char system_comand[XCDE_SYSTEM_COMAND_LENGTH]="\0" ; 

  char continuation_bit_buffer[XCDE_CONT_BIT_BUFFER_MAX_LENGTH]="\0" ; 
    
  unsigned 
    long int len_continuation_bit=0 ; 

  unsigned int 
    integer_coding_bit_offset=0 ;
  
  // used to compress integer 
  uchar *pp ; 

  // ----------------------
  // VARIABLES USED BY LZIP
  // ----------------------

  Byte *uncompr ; 

  uLong comprLen ;

  uLong uncomprLen ; 
  
  int cmp_err=0 ; 

  /*******************************************************************
	                 creates data structures
   *******************************************************************/

  setbuf(stdout, NULL) ; 

  setbuf(stderr, NULL) ; 

  body_pointers_cmp_buffer=calloc(body_pointers_cmp_buffer_dimension, 
				  sizeof(uchar)) ; 

  if (body_pointers_cmp_buffer == NULL)

    { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

    exit(-1) ; 
    }

  body_pcmp_point=body_pointers_cmp_buffer ; 

  expat_general_declared_entity=hcreate(XCDE_ENTITY_HT_DIMENSION) ; 

  expat_separators_table=hcreate(XCDE_SEPARATORS_HT_DIMENSION) ; 
  
  init_buffer(&textbuffer, 
	      TEXT_BUFFER_SIZE) ;

  /*******************************************************************
       inserts XML predefined general entities into the entity table
   *******************************************************************/

  hinsert((char *) "&amp;", 
	  strlen("&amp;"), 
	  NOTHING, 
	  (char *) "&", 
	  expat_general_declared_entity, 
	  0,
	  0,
	  XCDE_ENTITY_HASHTABLE) ;  
  
  hinsert((char *) "&lt;", 
	  strlen("&lt;"),
	  NOTHING, 
	  (char *) "<", 
	  expat_general_declared_entity, 
	  0,
	  0,
	  XCDE_ENTITY_HASHTABLE) ;  
  
  hinsert((char *) "&gt;", 
	  strlen("&gt;"),
	  NOTHING, 
	  (char *) ">", 
	  expat_general_declared_entity, 
	  0,
	  0,
	  XCDE_ENTITY_HASHTABLE) ;  
  
  hinsert((char *) "&apos;", 
	  strlen("&apos;"),
	  NOTHING, 
	  (char *) "'", 
	  expat_general_declared_entity, 
	  0,
	  0, 
	  XCDE_ENTITY_HASHTABLE) ;  
  
  hinsert((char *) "&quot;", 
	  strlen("&quot;"), 
	  NOTHING, 
	  (char *) "\"", 
	  expat_general_declared_entity, 
	  0,
	  0, 
	  XCDE_ENTITY_HASHTABLE) ;  
  
  /*******************************************************************
	 prints XCDE_BUILD informations and instructions 	      
   *******************************************************************/

  fprintf(stdout, "\t------------------------------------------------------------------") ; 
  
  fprintf(stdout, "\n\t\tXCDE_BUILD : Version 0.89 - By Andrea Mastroianni \n") ; 

  fprintf(stdout, "\n\t\t   X.ml C.ompressor D.ecompressor search E.ngine") ; 

  fprintf(stdout, "\n\t\t            XCDE File System Builder ") ;  

  fprintf(stdout, "\n\t\t\t   Last Version February 2002\n") ;

  fprintf(stdout, "\t------------------------------------------------------------------\n\n") ; 

  if (argc == 1) 

    { fprintf(stdout, "\t xcde_build [-v] [-c configfile] [-t] [-p] sourcefile") ; 

    fprintf(stdout, "\n\n\n\t-v : verbose") ;

    fprintf(stdout, "\n\n\t-c : configuration file") ;

    fprintf(stdout, "\n\n\t-t : insert tagstruct") ;

    fprintf(stdout, "\n\n\t-p : no proximity\n\n") ; 

    exit(-1) ; 
    }

  /*******************************************************************
	              reads the passed parameters
   *******************************************************************/

  for (k=1 ; k<argc; ++k) 

      if ((argv[k][0]=='-') && (argv[k][1]=='v'))
	
	verbosing_flag=1u ;
        
      else 

	if ((argv[k][0]=='-') && (argv[k][1]=='c'))

	  { if (k<(argc-1))
	    
	    { configFilename=(char *) malloc(strlen(argv[k+1])+1) ; 
	    
	    if (configFilename == NULL)

	      { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

	      DELETE_FILES ; 

	      exit(-1) ; 
	      }

	    strcpy(configFilename, 
		   argv[k+1]) ; 
	    
	    different_configfile_flag=1u ; 

	    ++k ; 
	    }

	  else
	    
	    { fprintf(stderr, "\n\tFatal Error: no valid configfile name\n") ; 
	    
	    exit(-1) ; 
	    }
	  }
  
	else
	  
	  if ((argv[k][0]=='-') && (argv[k][1]=='p')) 

	    proximity_flag=0u ; 

          else

	    if ((argv[k][0]=='-') && (argv[k][1]=='t'))

	      tagstruct_flag=1u ; 

	    else

	      if (inputFilename==NULL) 
		
		{ inputFilename=(char *) malloc(strlen(argv[k])+1) ; 

		if (inputFilename == NULL)

		  { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

		  DELETE_FILES ; 

		  exit(-1) ; 
		  }

		  strcpy(inputFilename, 
			 argv[k]) ; 
		}
    
	      else 

		{ fprintf(stderr, "\n\tFatal Error: no valid option") ; 
		
		DELETE_FILES ; 
		
		exit(-1) ; 
		}
  
  /*******************************************************************
                         opens or creates files
   *******************************************************************/

  for(k=0;k<3; ++k)

    { dictionaryFilename[k]=(char *) malloc(strlen(inputFilename)+strlen(XCDE_DICTIONARY_SUFFIX)+2) ; 

    if (dictionaryFilename[k] == NULL)

      { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

      DELETE_FILES ; 

      exit(-1) ; 
      }
    
    sprintf(dictionaryFilename[k], "%s%s%d", inputFilename, XCDE_DICTIONARY_SUFFIX,k) ; 

    if (verbosing_flag) 

      { fprintf(stdout, "\nCreating file %s", dictionaryFilename[k]) ; 

      if (k==0) fprintf(stdout, "TAG Dictionary ... ") ; 

      if (k==1) fprintf(stdout, "ATTR Dictionary ... ") ; 

      if (k==2) fprintf(stdout, "WORD Dictionary ... ") ; 
      }

    // opening dictionary files 
    if ((dictsFile[k]=fopen(dictionaryFilename[k],"wb"))==NULL) 
      
      { fprintf(stderr,"\n\tFatal Error: Dictionary file\n");
      
      DELETE_FILES ;
      
      exit(-1); 
      } 

    if (verbosing_flag) 
      
      fprintf(stdout, "OK") ; 
    }
  
  headerFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_HEADER_SUFFIX)+1) ; 

  if (headerFilename == NULL)

    { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

    DELETE_FILES ; 

    exit(-1) ; 
    }

  strcpy(headerFilename, 
	 inputFilename) ; 

  strcat(headerFilename, 
	 XCDE_HEADER_SUFFIX) ; 

  if (verbosing_flag) 

    fprintf(stdout, "\nCreating Header file %s ... ", headerFilename) ;

  if ((headerFile=fopen(headerFilename,"wb"))==NULL) 

    { fprintf(stderr,"\n\tFatal Error: Header file\n") ; 

    DELETE_FILES ; 

    exit(-1); 
    } 

  if (verbosing_flag) 

    fprintf(stdout, "OK") ; 

  bodyFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_BODY_SUFFIX)+1) ; 

  if (bodyFilename == NULL)
    
    { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 
    
    DELETE_FILES ; 

    exit(-1) ; 
    }

  strcpy(bodyFilename, 
	 inputFilename) ; 

  strcat(bodyFilename, 
	 XCDE_BODY_SUFFIX) ; 

  if (verbosing_flag)

    fprintf(stdout, "\nCreating Body file %s ... ", bodyFilename) ; 

  if ((bodyFile=fopen(bodyFilename,"wb"))==NULL) 

    { fprintf(stderr,"\n\tFatal Error: Body file\n");

    DELETE_FILES ; 

    exit(-1); 
    } 

  if (verbosing_flag) 

    fprintf(stdout, "OK") ; 

  IL_Filename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_IL_SUFFIX)+1) ; 

  if (IL_Filename == NULL)

    { fprintf(stderr, "\n\tFatal Error: problems during memory allocation\n") ; 

    DELETE_FILES ; 

    exit(-1) ; 
    }    
      
  strcpy(IL_Filename,
	 inputFilename) ; 

  strcat(IL_Filename, 
	 XCDE_IL_SUFFIX) ; 

  if (verbosing_flag) 

    fprintf(stdout, "\nCreating Inverted Lists file %s ... ", IL_Filename) ; 

  if ((IL_File=fopen(IL_Filename,"wb"))==NULL) 

    { fprintf(stderr,"\n\tFatal Error: Inverted Lists file\n");

    DELETE_FILES ; 

    exit(-1); 
    } 

  if (verbosing_flag) 

    fprintf(stdout, "OK") ; 

  // executes these operations only if the tagstruct option is setted 
  if (tagstruct_flag)

    { tagstructFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_TAGSTRUCT_SUFFIX)+1) ; 

    if (tagstructFilename == NULL) 

      { fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 
      
      DELETE_FILES ; 

      exit(-1); 
      } 

    strcpy(tagstructFilename, 
	   inputFilename) ; 
    
    strcat(tagstructFilename, 
	   XCDE_TAGSTRUCT_SUFFIX) ; 

    if (verbosing_flag) 

      fprintf(stdout, "\nCreating Tagstruct file %s ...", tagstructFilename) ; 

    if ((tagstructFile=fopen(tagstructFilename,"wb"))==NULL) 
    
      { fprintf(stderr,"\n\tFatal Error: Tagstruct file\n");

      DELETE_FILES ; 
    
      exit(-1); 
      } 
    
    if (verbosing_flag)
      
      fprintf(stdout, "OK") ; 
    }

  if (verbosing_flag)

    fprintf(stdout, "\nOpening Configuration file ...") ; 

  if (different_configfile_flag == 0u)

    if (setenv(XCDE_CONFIGDIR_ENV,
	       NULL, 
	       0))       
      
      { configFilename=(char *) malloc(strlen(XCDE_CONFIGFILE_STANDARD_NAME)+strlen(getenv(XCDE_CONFIGDIR_ENV))+2) ; 

      if (configFilename == NULL) 

	{ fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 

	DELETE_FILES ; 

	exit(-1); 
	} 
      
      sprintf(configFilename, "%s/%s", getenv(XCDE_CONFIGDIR_ENV), XCDE_CONFIGFILE_STANDARD_NAME) ; 
      }
  
    else 
      
      { configFilename=(char *) malloc(strlen(XCDE_CONFIGFILE_STANDARD_NAME)+1) ; 

      if (configFilename == NULL)

	{ fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 
	
	DELETE_FILES ; 

	exit(-1); 
	} 

      sprintf(configFilename, "%s", XCDE_CONFIGFILE_STANDARD_NAME) ; 
      }

  if ((configFile=fopen(configFilename, "r"))==NULL)
    
    { fprintf(stderr, "\n\tFatal Error: configuration file %s\n", configFilename) ; 
      
    DELETE_FILES ; 
    
    exit(-1) ;
    }
  
  // reads data contained in configFile
  read_conf_file(configFile) ; 
  
  fclose(configFile) ; 

  free(configFilename) ; 
  
  if (verbosing_flag) 
    
    fprintf(stdout, "OK") ; 

  // debug files are created only if the verbosing option is setted 
  if (verbosing_flag)

    { debugIndexFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_DEBUG_INDEX_SUFFIX)+1) ; 

    if (debugIndexFilename == NULL)

      { fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 
      
      DELETE_FILES ; 
    
      exit(-1) ;
      }
    
    strcpy(debugIndexFilename, 
	   inputFilename) ;

    strcat(debugIndexFilename, 
	   XCDE_DEBUG_INDEX_SUFFIX) ; 

    fprintf(stdout, "\nCreating Index Debugging file %s ...", debugIndexFilename) ; 
	
    if ((debugIndexFile=fopen(debugIndexFilename, "w"))==NULL) 

      { fprintf(stderr,"\n\tFatal Error: Index Debugging file\n") ; 

      DELETE_FILES ; 

      exit(-1); 
      } 
	
    fprintf(stdout, "OK") ; 

    debugPhysicFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_DEBUG_PHYSIC_SUFFIX)+1) ; 
    
    if (debugPhysicFilename == NULL)

      { fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 

      DELETE_FILES ; 

      exit(-1); 
      } 

    strcpy(debugPhysicFilename, 
	   inputFilename) ; 
	
    strcat(debugPhysicFilename, 
	   XCDE_DEBUG_PHYSIC_SUFFIX) ; 
    
    fprintf(stdout, "\nCreating Physical View Debugging file %s ... ", debugPhysicFilename) ; 

    // apertura del file con la visione a livello fisico 
    if ((debugPhysicView=fopen(debugPhysicFilename, "w")) == NULL)

      { fprintf(stderr, "\n\tFatal Error: Physic View Debugging file %s ...", debugPhysicFilename) ; 
	  
      DELETE_FILES ; 

      exit(-1) ; 
      }
	
    fprintf(stdout, "OK") ; 
	
    debugStatsFilename=(char *) malloc(strlen(inputFilename)+strlen(XCDE_DEBUG_STATS_SUFFIX)+1) ; 

    if (debugStatsFilename == NULL)
      
      { fprintf(stderr,"\n\tFatal Error: problems during memory allocation\n") ; 

      DELETE_FILES ; 

      exit(-1) ; 
      }
    
    strcpy(debugStatsFilename,
	   inputFilename) ; 
	
    strcat(debugStatsFilename, 
	   XCDE_DEBUG_STATS_SUFFIX) ; 
	
    fprintf(stdout, "\nCreating Statistic Debugging file %s ...", debugStatsFilename) ; 

    // apertura del file con le statistiche 
    if ((debugStatsFile=fopen(debugStatsFilename, "w")) == NULL)
	  
      { fprintf(stderr, "\nFatal Error: Statistic Debugging file %s ...", debugStatsFilename) ; 
	  
      DELETE_FILES ; 
	  
      exit(-1) ; 
      }
	
    fprintf(stdout, "OK") ; 
    }
  
  if (verbosing_flag) 
      
    fprintf(stdout, "\nOpening XML source file %s ...", inputFilename) ; 
    
  if ((inputFile=fopen(inputFilename, "r"))==NULL) 
    
    { fprintf(stderr, "\n\tFatal Error: XML Source file %s\n", inputFilename) ;
    
    DELETE_FILES ; 
      
    exit(-1) ; 
    }
  
  if (verbosing_flag) 
      
    fprintf(stdout, "OK") ; 

  /*******************************************************************
                       maps source file into the memory
   *******************************************************************/    

  result=stat(inputFilename ,
	      &sbuf); 
    
  if (result == -1) 

    { fprintf(stderr, "\n\tFatal Error: problems in stat function on file %s\n", inputFilename) ; 

    DELETE_FILES ; 

    exit(-1) ; 
    }

  inputFilesize = (int) sbuf.st_size;
    
  ht = hcreate((inputFilesize/XCDE_HASHTABLE_RATIO == 0) ? XCDE_HASHTABLE_RATIO : inputFilesize / XCDE_HASHTABLE_RATIO) ;

  expat_source_pointer = (char *) mmap(NULL,
				       inputFilesize,
				       PROT_READ,
				       MAP_SHARED,
				       fileno(inputFile),
				       0);

  if (expat_source_pointer == NULL) 

    { fprintf(stderr, "\n\tFatal Error: problems in mapping file %s\n", inputFilename) ; 

    DELETE_FILES ; 

    exit(-1) ; 
    }

  /*******************************************************************
                          configures EXPAT system 
   *******************************************************************/  

  parser = XML_ParserCreate(NULL) ; 
    
  if (!parser) 
	
    { fprintf(stderr, "\n\tFatal Error: problems with EXPAT Parser\n") ; 

    DELETE_FILES ; 
    
    exit(-1) ; 
    }
 
  XML_SetDoctypeDeclHandler(parser, 
			    doctypestart,
			    doctypeend) ; 
  
  XML_SetParamEntityParsing(parser, 
			    XML_PARAM_ENTITY_PARSING_ALWAYS) ; 

  XML_SetElementHandler(parser, 
			start, 
			end) ;

  XML_SetCharacterDataHandler(parser, 
			      text)  ;

  XML_SetCdataSectionHandler(parser, 
			     cdstart, 
			     cdend) ;

  XML_SetInternalParsedEntityDeclHandler(parser, 
					 InternalEntity) ;
  
  XML_SetDefaultHandlerExpand(parser, 
			      defa) ;
  
  /*******************************************************************
       		       parsing the XML source 	      
   *******************************************************************/

  if (verbosing_flag) 

    fprintf(stdout, "\n\nParsing the XML source ... ") ; 

  for ( ; ; )
  
    { int done=0 ;
     
    int bytes_read=0 ;
	
    bytes_read=fread(expat_parsing_buffer, 
		     1, 
		     XCDE_EXPAT_PARSING_BUFFER_SIZE, 
		     inputFile) ;

    if (ferror(inputFile))

      { fprintf(stderr, "\n\tFatal Error: problems in reading source file\n") ; 

      DELETE_FILES ; 

      exit(-1) ; 
      }
	  
    done=feof(inputFile) ;
     
    if (!XML_Parse(parser, 
		   expat_parsing_buffer,
		   bytes_read,
		   done)) 

      { fprintf(stderr, "\n\tFatal Error: problems in parsing raw %d, string %s\n",

		XML_GetCurrentLineNumber(parser),

		XML_ErrorString(XML_GetErrorCode(parser))) ;

      DELETE_FILES ; 
      
      exit(-1) ;  
      }

    if (done) break ;
    }

  if (verbosing_flag)
    
    fprintf(stdout, "OK") ; 
  
  /*******************************************************************
     builds the Huffman tree with the tokens found during parsing
                        and writes dictionaries 
  *******************************************************************/
  
  if (verbosing_flag) 

    fprintf(stdout, "\n\nBuilds Huffman Tree ... ") ; 

  Huffman_tree=Huffman_byte_code(firstcw,
				 offsetcw,
				 count_depth);

  if (verbosing_flag)

    fprintf(stdout, "OK") ; 

  if (verbosing_flag)

    fprintf(stdout, "\nWriting Header file %s ... ", headerFilename) ; 
  
  for (k=1; k<=4; k++) 
    for (temp=firstcw[k],j=3; j>=0; j--)
      fputc((temp >> 7*j) & 0x7F, headerFile) ;

  for (k=1; k<=4; k++) 
    for (temp=offsetcw[k],j=3; j>=0; j--)
      fputc((temp >> 8*j) & 0xFF, headerFile) ;

  if (verbosing_flag)
    
    fprintf(stdout, "OK") ;

  for(k=0; k<3; ++k)

    { fputc(0, dictsFile[k]) ;
 
    fprintf(stdout, "\nWriting Dictionary file %s ... OK", dictionaryFilename[k]) ; 
    }

  max_length=0 ; 
  
  current_level=5 ;
  
  count=0 ;

  for(i=0 ; i<number_tokens; i++)

    { if (Huffman_tree[i]->cw_len != current_level)

      { current_level = Huffman_tree[i]->cw_len ;

      if (current_level > max_length) 

	max_length=current_level ;

      ++number_levels ; 
      
      count=0 ;  
      }

    if (Huffman_tree[i]->cw_len <= 0) 
      
      { fprintf(stderr,"\n\tFatal Error: problems with token %s\n", Huffman_tree[i]->str) ; 
      
      DELETE_FILES ; 

      exit(-1) ; 
      }	

    Huffman_tree[i]->codeword = firstcw[current_level]+count ;

    ++dict_elem[current_level-1][Huffman_tree[i]->type] ; 
      
    count++;

    if (Huffman_tree[i]->len_str==0) ;

    else
      
      for(j=0; j<Huffman_tree[i]->len_str; j++)
	
	fputc(Huffman_tree[i]->str[j],
	      dictsFile[Huffman_tree[i]->type]) ;

    fputc(0,dictsFile[Huffman_tree[i]->type]) ;
    }
  
  for (temp=max_length,j=3; j>=0; j--)

    fputc((temp >> 8*j) & 0xFF, headerFile) ; 

  for(k=0; k<max_length; ++k) 
    for (i=0; i<3; i++) 
      for (temp=dict_elem[k][i],j=3; j>=0; j--)
	fputc((temp >> 8*j) & 0xFF, headerFile) ; 
  
  for(k=0; k<3; ++k)

    { fclose(dictsFile[k]);
    
    if (verbosing_flag)
      
      fprintf(stdout, "\nCompressing file %s ... ", dictionaryFilename[k]) ; 
    
    sprintf(system_comand, "gzip -f -S .cmp %s", dictionaryFilename[k]) ; 

    result=system(system_comand) ; 
    
    if (result == -1)

      { fprintf(stderr, "\n\tFatal Error: problems compressing file %s\n", dictionaryFilename[k]) ; 

      DELETE_FILES ;

      exit(-1) ;
      }

    if (verbosing_flag)

      fprintf(stdout, "OK") ;
    }

  /******************************************************************* 
              writes the Body file, with a second pass by Expat          
   *******************************************************************/

  XML_ParserFree(parser) ; 

  xml_code=NULL ;

  xml_dimension=0 ;

  xml_position=0 ; 

  last_expandend_position=-1 ; 

  expat_number_tag_opened=0 ; 

  parser=XML_ParserCreate(NULL) ; 

  if (!parser) 

    { fprintf(stderr, "\n\tFatal Error: problems with EXPAT Parser\n") ; 

    DELETE_FILES ; 
    
    exit(-1) ; 
    }
    
  XML_SetParamEntityParsing(parser, 
			    XML_PARAM_ENTITY_PARSING_ALWAYS) ; 

  XML_SetDoctypeDeclHandler(parser, 
			    doctypestart,
			    doctypeend) ; 

  XML_SetElementHandler(parser, 
			startcod, 
			endcod) ;

  XML_SetCharacterDataHandler(parser, 
			      textcod)  ;

  XML_SetCdataSectionHandler(parser, 
			     cdstartcod, 
			     cdendcod) ;

  XML_SetDefaultHandlerExpand(parser, 
			      defacod) ;

  fseek(inputFile, 
	0L, 
	SEEK_SET) ;
  
  if (verbosing_flag)

    fprintf(stdout, "\nWriting Body file %s ... ", bodyFilename) ; 

  for ( ; ; )
    { int done=0 ;

    int bytes_read=0 ; 
	
    bytes_read=fread(expat_parsing_buffer,
		     1, 
		     XCDE_EXPAT_PARSING_BUFFER_SIZE,
		     inputFile) ;

    if (ferror(inputFile))

      { fprintf(stderr, "\n\tFatal Error: problems in reading source file\n") ; 

      DELETE_FILES ; 

      exit(-1) ; 
      }

    done = feof(inputFile) ;

    if (!XML_Parse(parser, 
		   expat_parsing_buffer,
		   bytes_read,
		   done)) 
      
      { fprintf(stderr, "\n\tFatal Error: problems in parsing raw %d, string %s\n",
		
		XML_GetCurrentLineNumber(parser),
		
		XML_ErrorString(XML_GetErrorCode(parser))) ;
      
      DELETE_FILES ; 
      
      exit(-1) ;  
      }

    if (done) break ;
    }	 
  
  if (verbosing_flag)

    fprintf(stdout, "OK") ; 
  
  XML_ParserFree(parser) ; 
  
  fclose(inputFile) ; 

  // compress and write the last block of the body file
  if (pointer_decompress_buffer > 0)
    
    { 
      if (diff_position > 0) 
      
      { // checks if there is enough space in the buffer to compress block point
	if ((body_pcmp_point-body_pointers_cmp_buffer) > (body_pointers_cmp_buffer_dimension-K))
	  
	  { new_body_pointers_point=(int) (body_pcmp_point-body_pointers_cmp_buffer) ; 
	  
	  body_pointers_cmp_buffer=realloc(body_pointers_cmp_buffer, 
					   body_pointers_cmp_buffer_dimension*2) ; 
	  
	  body_pcmp_point=(uchar *) (new_body_pointers_point+body_pointers_cmp_buffer) ;
	  
	  body_pointers_cmp_buffer_dimension*=2 ; 
	  }

	write_delta_code((uchar **) &body_pcmp_point,
			 (int *) &body_bit_offset,
			 (uint) new_diff_position) ; 
	
	++number_body_points ; 
      }
    
      uncompr=(Byte *) zlib_decompress_buffer ; 
      
      uncomprLen=pointer_decompress_buffer ; 
      
      comprLen=2*XCDE_COMPRESS_BLOCK_SIZE ; 
    
      cmp_err=compress2((Bytef *) zlib_compress_buffer,
			(uLongf *) &comprLen, 
			(const Bytef *) uncompr, 
			(uLong) uncomprLen, 
			Z_BEST_COMPRESSION) ;
	
      if (cmp_err != Z_OK) 
	
	{ fprintf(stderr, "\n\tFatal Error: problems with zlib compression\n") ; 

	DELETE_FILES ; 
	
	exit(-1) ; 
	}

      for (i=0 ; i<comprLen; ++i) 
	  
	fputc((char) zlib_compress_buffer[i],
	      bodyFile) ; 
    }
  
  pointer_decompress_buffer=0 ; 

  if (body_bit_offset > 0) 

    ++body_pcmp_point ; 

  if (verbosing_flag)

    fprintf(debugStatsFile, 
	    "\nNumber of pointers to Body File %d ", number_body_points) ; 
  
  continuation_bit_c((unsigned long) inputFilesize, 
		     (char *) continuation_bit_buffer, 
		     (unsigned int) 0,
		     (unsigned long *) &len_continuation_bit) ; 
  
  for (j=0 ; j<(len_continuation_bit/8); ++j) 
    
    fputc((char) continuation_bit_buffer[j], 
	  headerFile) ; 

  fputc((unsigned char) proximity_flag, 
	headerFile) ; 
  
  fputc((unsigned char) tagstruct_flag, 
	headerFile) ; 

  continuation_bit_c((unsigned long) number_body_points, 
		     (char *) continuation_bit_buffer, 
		     (unsigned int) 0,
		     (unsigned long *) &len_continuation_bit) ; 	

  for(j=0 ; j<(len_continuation_bit/8); ++j) 
    
    fputc((char) continuation_bit_buffer[j], 
	  headerFile) ; 
  
  if (number_body_points > 1) 
    
    { continuation_bit_c((unsigned long) (body_pcmp_point-body_pointers_cmp_buffer), 
			 (char *) continuation_bit_buffer, 
			 (unsigned int) 0,
			 (unsigned long *) &len_continuation_bit) ;

    for(j=0 ; j<(len_continuation_bit/8); ++j) 
      
      fputc((char) continuation_bit_buffer[j], 
	    headerFile) ; 
    
    for(j=0 ; j<(body_pcmp_point-body_pointers_cmp_buffer) ; ++j) 

      fputc((uchar) body_pointers_cmp_buffer[j], 
	    headerFile) ; 
    
    if (verbosing_flag)

      fprintf(debugStatsFile, 
	      "\nLength of the body pointers list %d", (body_pcmp_point-body_pointers_cmp_buffer)) ; 

    free(body_pointers_cmp_buffer) ; 
    }
  
  number_IL_table_pointer = number_tokens / XCDE_IL_POINTER_RATIO ; 
  
  if ((number_tokens % XCDE_IL_POINTER_RATIO) > 0)

    ++number_IL_table_pointer ; 

  IL_pointers_buff=(uchar **) malloc(sizeof(uchar *)) ;

  (*IL_pointers_buff)=(uchar *) malloc(number_IL_table_pointer*2*sizeof(int)) ; 

  IL_pointers_buff_length=number_IL_table_pointer*2*sizeof(int) ; 

  // writes the Inverted Lists file 
  output_IL(Huffman_tree,
	    IL_File,
	    number_tokens,
	    IL_pointers_buff,
	    &IL_pointers_buff_length) ; 
  
  // writes the IL table in the header file 
  for(k=0; k<IL_pointers_buff_length; ++k) 
    
    fputc((*IL_pointers_buff)[k], 
	  headerFile) ; 
  
  free(*IL_pointers_buff) ; 

  free(IL_pointers_buff) ; 

  if (verbosing_flag)
    
    fprintf(stdout, "\n") ; 

  // writes the Index Debugging File 
  if (verbosing_flag) 
    
    verbose_output_index(Huffman_tree,
			 debugIndexFile,
			 number_tokens) ; 

  if (tagstruct_flag)

    Build_Context_File(tagstructFile,
		       Huffman_tree,
		       number_tokens,
		       number_tagstruct_intervals) ; 

  // frees allocated memory and closes files
  fclose(headerFile) ; 

  free(headerFilename) ; 

  fclose(bodyFile) ; 

  free(bodyFilename) ; 

  fclose(IL_File) ; 

  free(IL_Filename) ; 
  
  if (tagstruct_flag) 

    { fclose(tagstructFile) ; 

    free(tagstructFilename) ; 
    }

  if (verbosing_flag)

    { fclose(debugPhysicView) ; 

    free(debugPhysicFilename) ; 

    fclose(debugStatsFile) ; 

    free(debugStatsFilename) ; 

    fclose(debugIndexFile) ;

    free(debugIndexFilename) ; 
    }

  hdestroy(ht) ; 

  hdestroy(expat_general_declared_entity) ; 

  hdestroy(expat_separators_table) ; 

  free(Huffman_tree) ; 
  
  return(1) ;
}

// function that writes the IL file and computes the IL index table
void output_IL(Hashptr *table,
	       FILE *invdex,
	       int dimension,
	       uchar **pos, 
	       int *npos)
{ // counter variables 
  int k=0 ; 
  int j=0 ;

  // buffer used to compress lists by delta code and continuation bit 
  uchar *buffer=(uchar *) calloc(BUFFER_SIZE, 1) ; 

  int buffer_dimension=BUFFER_SIZE ; 

  // pointer that moves across the buffer 
  uchar *buffer_pointer ; 

  // pointer to move across the buffer passed as parameter 
  uchar *pos_pointer ; 

  int bit_offset=0 ; 

  // used to compute the delta difference 
  int diff_list_elements=0 ;

  int previous_element=0 ; 

  int position=0 ; 

  int previous_position=0 ; 

  int positions_diff=0 ; 

  int pos_bit_offset=0 ; 

  int length_list=0 ; 

  unsigned 
    long length_continuation_bit=0 ; 

  indexList list=NULL ; 

  unsigned char 
    escape_condition=0 ; 

  // variables used to compute the Golomb code
  unsigned 
    int Golomb_K=0 ; 

  char Golomb_Buff[XCDE_GOLOMB_BUFFER_MAX_LENGTH] ; 

  unsigned 
    long length_golomb_code=0 ; 

  // statistical variables 
  int number_lists=0 ; 
  
  int number_lists_with_proximity=0 ; 

  int number_proximity_lists_elements=0 ; 

  int number_lists_elements=0 ; 

  int number_lists_elements_escape=0 ; 

 /******************************************************************* 
	                 initializes variables 
  *******************************************************************/

  pos_pointer=*pos ; 

  position=0 ;
 
  previous_position=0 ; 

  pos_bit_offset=0 ; 
  
  clean_buffer(*pos, 
	       *npos) ; 

  /******************************************************************* 
	                 loops over all tokens
   *******************************************************************/

  for(k=0; k<dimension; ++k) 

    { // sets the IL table index 
      if (((k % (XCDE_IL_POINTER_RATIO)==0)) && (k>0))
	  
	  { positions_diff=position-previous_position ;  
	  
	  previous_position=position ;  

	  // adds 1 to positions difference to avoid the zero problem
	  write_delta_code(&pos_pointer, 
			   &pos_bit_offset, 
			   (uint) positions_diff+1) ; 
	  
	  // checks if there is enough space, else allocates much memory 
	  if ((pos_pointer-(*pos)) > (*npos/2))

	      { int point=0 ; 
	      
	      point=(pos_pointer-(*pos)) ; 
	    
	      *pos=realloc(*pos, 
			   2*(*npos)) ; 

	      *npos=2*(*npos) ; 

	      pos_pointer=*pos+point ; 
	      }
	  }
	  
      list=table[k]->byte_list ; 
	
      // the number of elements in tag lists must be even
      if ((table[k]->type == TAG) && 
	  ((table[k]->num_byte_list % 2) != 0))
	  
	{ fprintf(stderr, "\n\tFatal Error: unexpected value in TAG %d %s\n", k, table[k]->str) ; 

	DELETE_FILES ; 
	
	exit(-1) ; 
	}
      
      // computes the number of intervals for tagstruct construction 
      if ((table[k]->type == TAG) && (tagstruct_flag))

	number_tagstruct_intervals+=(table[k]->num_byte_list/2) ; 

      if (list != NULL) 
       
	{ ++number_lists ; 
	
	diff_list_elements=list->occ ; 

	buffer_pointer=buffer ; 
	 
	bit_offset=0 ; 
	 
	// gets the mean value of k to compute the Golomb code 
	compute_optimal_k(&Golomb_K, 
			  list, 
			  table[k]->num_byte_list, 
			  table[k]->rank_list, 
			  proximity_flag, 
			  table[k]->type) ; 
	
	// writes the number of elements in the list 
	write_golomb_code(&buffer_pointer,
			  &bit_offset,
			  (uint) table[k]->num_byte_list,
			  Golomb_K) ; 
	
	// checks if there is enough space, else allocates memory 
	if ((buffer_pointer-buffer) > (buffer_dimension/2))
	    
	      { int count=0 ; 
	      
	      count=(buffer_pointer-buffer) ; 

	      buffer=realloc(buffer, 
			     2*buffer_dimension) ; 
	      
	      buffer_dimension=2*buffer_dimension ; 

	      buffer_pointer=(buffer+count) ; 
	      }

	if ((table[k]->type==WORD) && (proximity_flag))

	  { ++number_lists_with_proximity ; 

	  if (table[k]->num_rank_list != table[k]->num_byte_list)

	    { fprintf(stderr, "\n\tFatal Error: unexpeted value in TAG %d %s\n", k, table[k]->str) ; 

	    DELETE_FILES ; 
	    
	    exit(-1) ; 
	    }
	  }
	
	  previous_element=0 ; 
	  
	  escape_condition=0 ; 
	 
	  while (list != NULL) 
	    
	    { if ((buffer_pointer-buffer) > (buffer_dimension/2))

	      { int count=0 ; 

	      count=(buffer_pointer-buffer) ; 

	      buffer=realloc(buffer, 
			     2*buffer_dimension) ; 
	      
	      buffer_dimension=2*buffer_dimension ; 

	      buffer_pointer=(buffer+count) ; 
	      }
	    
	    // it's a escape list
	    if ((list != NULL) && (!escape_condition) && (list->occ==-1))
	       
	      { escape_condition=1 ; 
		
	      ++number_lists_elements_escape ; 

	      write_golomb_code(&buffer_pointer,
				&bit_offset,
				(uint) 1,
				Golomb_K) ; 

	      list=list->next ; 
	      }
	      
	    else 
	      
	      // the escape list ends 
	      if((list != NULL) && (escape_condition) && (list->occ==-1))
		 
		{ escape_condition=0 ; 
		 
		write_golomb_code(&buffer_pointer, 
				  &bit_offset,
				  (uint) 1,
				  Golomb_K) ; 
		
		list=list->next ; 
		}

	      // it's an element of a escape list 
	      else if((list != NULL) && (escape_condition))
		
		{ diff_list_elements=list->occ ; 
		 
		// adds the value 2 to the difference to code the -1 element 
		// and to avoid the zero problems 
		write_golomb_code(&buffer_pointer, 
				  &bit_offset,
				  (uint) diff_list_elements+2,
				  Golomb_K) ; 
		
		++number_lists_elements_escape ; 
		
		list=list->next ; 
		}

	      // it's an element of a normal list 
	      else if ((list!= NULL) && (!escape_condition) && (list->occ!=-1))
		 
		{ diff_list_elements=list->occ-previous_element ; 
		
		previous_element=list->occ ; 
 
		++number_lists_elements ; 

		// adds the value 2 to the difference to code the -1 element 
		// and to avoid the zero problems 		
		write_golomb_code(&buffer_pointer,
				  &bit_offset,
				  (uint) diff_list_elements+2,
				  Golomb_K) ; 

		list=list->next ; 
		} 
	      
	      // writes the value 1 to code the escape list end  
	      else if ((list==NULL) && (escape_condition))
		 
		write_golomb_code(&buffer_pointer,
				  &bit_offset,
				  (uint) 1,
				  Golomb_K) ; 
	    } 
	  
	  // writes proximity lists
	  if (proximity_flag) 
	    
	    { list=table[k]->rank_list ; 

	    if (list != NULL)

	      { diff_list_elements=list->occ ; 

	      ++number_lists_with_proximity ; 
	      }

	    while(list != NULL) 
	   
	      { // checks if there is enough space, else allocates memory
		if ((buffer_pointer-buffer) > (buffer_dimension/2))
		  
		  { int count=0 ; 
		  
		  count=(buffer_pointer-buffer) ; 

		  buffer=realloc(buffer, 
				 2*buffer_dimension) ; 
		  
		  buffer_dimension=2*buffer_dimension ; 

		  buffer_pointer=(buffer+count) ; 
		  }

		previous_element=list->occ ; 
		
		++number_proximity_lists_elements ; 

		// adds only 1 to the difference, because theresn't the 
		// escape problem
		write_golomb_code(&buffer_pointer, 
				  &bit_offset, 
				  (uint) diff_list_elements+1,
				  Golomb_K) ; 
		  
		list=list->next ; 
		  
		if (list != NULL) 
		    
		  diff_list_elements=(list->occ)-previous_element ; 
	      } 
	    }
	
	  length_list=((unsigned long)(buffer_pointer-buffer)) ; 
	  
	  if (bit_offset> 0) 

	    ++length_list ; 
	 
 	  continuation_bit_c((unsigned long) Golomb_K,
  			     (char *) Golomb_Buff,
  			     (unsigned int) 0,
  			     (unsigned long *) &length_golomb_code) ; 

  	  length_list+=(length_golomb_code) ; 

	  continuation_bit_c((unsigned long) length_list, 
			     (char *) (buffer_pointer+3),
			     (unsigned int) 0,
			     (unsigned long *) &length_continuation_bit) ; 
	  
	  for(j=0 ; j<(length_continuation_bit/8); ++j) 
	    
	    { fputc(buffer_pointer[j+3], 
		    invdex) ; 
	   
	    buffer_pointer[j+3]=0 ;
	   
	    ++position ; 
	    }
	  
	  for(j=0 ; j<(length_golomb_code/8); ++j) 
	    
	    { fputc(Golomb_Buff[j], 
		    invdex) ; 
	   
	    ++position ; 
	    }
	  
	  for(j=0; (buffer+j < buffer_pointer); ++j)
	    
	    { fputc(buffer[j], 
		    invdex) ;
	    
	    ++position ; 
	    
	    buffer[j]=0; 
	    }
	  
	  if (bit_offset > 0)  
	    
	    { fputc(*buffer_pointer, 
		    invdex) ; 
	      
	    ++position ; 
	      
	    *buffer_pointer=0 ; 
	    }
	  }
	
	else 
       
	  { fputc(0, 
		  invdex) ; 

	  ++position ; 
	  }
    }
      
 /******************************************************************* 
                    sets variables and prints results
  *******************************************************************/

  (*npos)=(int) (pos_pointer-(*pos)) ; 
  
  if (pos_bit_offset > 0) 
    
    ++(*npos) ; 
  
  if (verbosing_flag) 
	
    { fprintf(debugStatsFile, "\nInterval of IL Index Table Pointers : %d ", XCDE_IL_POINTER_RATIO) ; 
	
    fprintf(debugStatsFile, "\nNumber of total lists : %d", number_lists) ; 

    fprintf(debugStatsFile, "\nNumber of position elements in lists : %d", number_lists_elements) ;

    fprintf(debugStatsFile, "\nNumber of offset elements in lists : %d", number_lists_elements_escape) ; 

    if (proximity_flag)
      
      { fprintf(debugStatsFile, "\nNumber of proximity lists : %d", number_lists_with_proximity) ; 

       fprintf(debugStatsFile, "\nNumber of elements in proximity lists : %d", number_proximity_lists_elements) ; 
       }

     else fprintf(debugStatsFile, "\nNo proximity option") ;
    }

  // libera la memoria allocata 
  free(buffer) ; 

  return ;   
}

void compute_optimal_k(unsigned int *k, 
		       indexList ByteList,
		       unsigned int numByteList,
		       indexList ProxList,
		       unsigned char Prox,
		       unsigned short int type) 
{ indexList list=NULL ;
  
 int diff_lists_elements=0 ;  

 int previous_element=0 ; 

 unsigned 
   char escape_condition=0u ;  
  
 unsigned int 
   sum=0 ; 
 
 unsigned 
   int mean=0 ; 

 unsigned 
   int number_elements=0 ; 

 /******************************************************************* 
        computes the optimal k to obtain the highest compression 
  *******************************************************************/
 
 list=ByteList ; 

 diff_lists_elements=list->occ ; 

 sum+=numByteList ;

 ++number_elements ; 

 if ((Prox==1) && (type==WORD))
    
   { ++number_elements ; 

   sum+=numByteList ; 
   }
 
 escape_condition=0u ; 
	 
 while (list != NULL) 
    
   { // begin an escape condition list
     if ((list != NULL) && (!escape_condition) && (list->occ==-1))
		
       { escape_condition=1u ; 
	
       sum+=1 ; 

       ++number_elements ; 
       
       list=list->next ; 
       }
	      
     else 

       // the escape list ends 
       if ((list != NULL) && (escape_condition) && (list->occ==-1))
	 
	 { escape_condition=0 ; 
		
	 sum+=1 ;

	 ++number_elements ; 
	 
	 list=list->next ; 
	 }
     
       // it's an element of the escape list 
       else if((list != NULL) && (escape_condition))
		 
	 { diff_lists_elements=list->occ ; 
		
	 sum+=(diff_lists_elements+2) ; 

	 ++number_elements ; 
	 
	 list=list->next ; 
	 }
     
       else 

	 // it's an element of a normal list 
	 if ((list!= NULL) && (!escape_condition) && (list->occ!=-1))
	   
	   { diff_lists_elements=list->occ-previous_element ; 
	  
	   previous_element=list->occ ; 

	   sum+=(diff_lists_elements+2) ; 

	   ++number_elements ; 
	   
	   list=list->next ; 
	   } 
     
	 else 

	   if ((list==NULL) && (escape_condition))
		 
	     { sum+=1 ; 
	     
	     ++number_elements ; 
	     }
     
   } 

 // reads the proximity list 
 if ((Prox==1) && (type==WORD))
	    
   { list=ProxList ; 

   if (list != NULL)

     diff_lists_elements=list->occ ; 

   while(list != NULL) 
	   
     { previous_element=list->occ ; 

     sum+=(diff_lists_elements+1) ;

     ++number_elements ; 

     list=list->next ; 
		  
     if (list != NULL) 
	
       diff_lists_elements=((list->occ)-previous_element) ; 
     } 
   }

 mean=(sum/number_elements) ; 

 // computes the optimal value of k, that's the mean multiplied by 0.69
 *k=((unsigned int) (floor((double) mean*0.69))) ; 
 
 return; 
}
  

  
