 /********************************************************************
	                     xcde_build.h
        contains constants needed by the XCDE_Build program 
	         Xml Compressor Decompressor search Engine
	                    Building Program
	           Paolo Ferragina - Andrea Mastroianni 
	Dipartimento di Informatica - Universita' di Pisa 
	                 ferragin@di.unipi.it
	                mastroi@cli.di.unipi.it
 ********************************************************************/

 /********************************************************************
                             files header used 
 *********************************************************************/ 
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h> 
#include<sys/mman.h> 
#include<sys/stat.h>
#include<string.h>
#include<ctype.h>
#include<unistd.h>
#include"textbuffer.h"
#include"hashfunc.h"
#include"xmlparse.h"
#include"zlib.h"
/********************************************************************
                            constants used
 *********************************************************************/ 
#define _StartConfComment 35 // #
#define _StartConfEntDecl 38 // &
#define _EndConfEntDecl 59 // ; 
#define _StartElement 60  // <
#define _SepTagAttr 38 // &
#define _SepValAttr 61 // =
#define _CloseTagElement 47 // '/'
#define _DoppiApici 34 // 
#define _Apici 39 // '
#define _PuntoEVirgola 59 // ; 

 /*******************************************************************
                        data structures used
  *******************************************************************/ 
typedef unsigned char uchar ; 

 /*******************************************************************
                             macros used  
  *******************************************************************/ 
#define DELETE_FILES { register int k ;                   \
                       if (inputFilename != NULL)         \
                         { if (inputFile != NULL)         \
                            fclose(inputFile) ;           \
                           free(inputFilename) ;          \
			 }                                \
                       if (configFilename != NULL)        \
                        { if (configFile != NULL)         \
			   fclose(configFile) ;           \
                          free(configFilename) ;          \
			}                                 \
                       if (bodyFilename != NULL)          \
                        { if (bodyFile != NULL)           \
			   fclose(bodyFile) ;             \
                          unlink(bodyFilename) ;          \
                          free(bodyFilename) ;            \
			}                                 \
                       if (headerFilename != NULL)        \
                        { if (headerFile != NULL)         \
			   fclose(headerFile) ;           \
                          unlink(headerFilename) ;        \
                          free(headerFilename) ;          \
                        }                                 \
                       if (IL_Filename != NULL)           \
                        { if (IL_File != NULL)            \
			   fclose(IL_File) ;              \
                          unlink(IL_Filename) ;           \
                          free(IL_Filename) ;             \
                        }                                 \
		       if (tagstructFilename != NULL)     \
			{ if (tagstructFile != NULL)      \
			   fclose(tagstructFile) ;  	  \
			  unlink(tagstructFilename) ;     \
			  free(tagstructFilename) ; 	  \
    			}                                 \
                       for(k=0 ; k<XCDE_NUMBER_DICT; ++k) \
                       if (dictionaryFilename[k] != NULL) \
                         { if (dictsFile[k] != NULL)      \
			    fclose(dictsFile[k]) ;         \
                           unlink(dictionaryFilename[k]) ; \
                           free(dictionaryFilename[k]) ;   \
                         }                                 \
		       if (debugPhysicFilename != NULL)   \
                       {  if (debugPhysicView != NULL)    \
			   fclose(debugPhysicView) ;      \
			  unlink(debugPhysicFilename) ;   \
			  free(debugPhysicFilename) ;     \
			}                                 \
		       if (debugIndexFilename != NULL)    \
			{ if (debugIndexFile != NULL)     \
			   fclose(debugIndexFile) ;       \
			  unlink(debugPhysicFilename) ;   \
			  free(debugPhysicFilename) ;     \
			}                                 \
		       if (debugStatsFilename != NULL) 	  \
		        { if (debugStatsFile != NULL)     \
			   fclose(debugStatsFile) ; 	  \
			  unlink(debugStatsFilename) ;    \
			  free(debugStatsFilename) ;      \
			}				  \
		       hdestroy(ht) ;                     \
		       hdestroy(expat_general_declared_entity) ; \
		       hdestroy(expat_separators_table) ; \
                       hdestroy(expat_attribute_separators_table) ; \
                       }

/*******************************************************************
       	                     functions used 
 *******************************************************************/ 

 /*******************************************************************
                             expat handlers
 *******************************************************************/ 
// DTD start handler
void doctypestart(void *userData,
		  const XML_Char *doctypeName);
// DTD end handler
void doctypeend(void *userData);

/*  //  */
/*  void handler(XML_Parser parser, */
/*  	     const XML_Char *context, */
/*  	     const XML_Char *base, */
/*  	     const XML_Char *system, */
/*  	     const XML_Char *publicId) ; */

// element start handler
void 
start(void *data,
      const char *el, 
      const char **attr) ;

// element contain start coding handler
void 
startcod(void *data,
	 const char *el, 
	 const char **attr) ;

// element end buffer
void 
end(void *data,
    const char *el) ;

// element endcode buffer
void 
endcod(void *data,
       const char *el) ;

// gestore degli elementi di testo 
void 
text(void *data, 
     const char *t, 
     int len) ;

// gestore della codifica degli elemento di testo 
void 
textcod(void *data, 
	const char *t, 
	int len) ;

// gestore dell'inizio di una sezione CDATA
void 
cdstart(void *data) ;

// gestore della codifica dell'inizio 
// di una sezione CDATA
void 
cdstartcod(void *data) ;

// gestore della fine di una sezione CDATA
void 
cdend(void *data) ;

// gestore della codifica della fine di 
// una sezione CDATA
void 
cdendcod(void *data) ;

// gestore dei riferimenti alle entita' generali interne
// e degli elementi che non appartengono a quelli gestiti
// dalle funzioni precedenti 
void defa(void *data,
	  const XML_Char *s,
	  int len) ;

// gestore della codifica dei riferimenti alle entita' 
// generali interne e agli elementi che non appartengono 
// a quelli gestiti dalle funzioni precedenti 
void defacod(void *data,
	     const XML_Char *s,
	     int len) ;

// gestore delle dichiarazioni delle entita'
// generali interne all'interno della DTD
void InternalEntity(void *userData,
		    const XML_Char *entityName,
		    const XML_Char *replacementText,
		    int replacementTextLength) ;

// gestore dei commenti del sorgente XML
void CommentHandler(void *userData,
		    const XML_Char *data) ; 
/*******************************************************************
                    altre funzioni utilizzate 
 *******************************************************************/ 
// funzione utilizzata per la lettura del file di configurazione
void read_conf_file(FILE *cfg) ; 

// funzione utilizzata per scrivere l'indice in output nel caso 
// in cui sia abilitata l'opzione di debug 
void debug_index_output(Hashptr* Huff, 	
			FILE *index,	
			int dimension) ; 

void output_IL(Hashptr *table,
	       FILE *invdex,
	       int dimension,
	       uchar **pos, 
	       int *npos) ;

// funzione utilizzata per acquisire il prossimo token
// dal buffer 'text', utilizzando i separatori contenuti
// in 'separator'; il separatore effettivamente utilizzato
// viene memorizzato in 'sep' e l'ampiezza del testo scansito
//  e' contenuta in maxlen 
int get_next_token(char *text, 
		   const char *separator, 
		   char *sep,
		   int maxlen) ;

// funzione che determina la corrispondenza fisica di un elemento 
// presente logicamente nel sorgente XML 
unsigned char phy_corr(char **entity,
		       int *entity_len,
		       unsigned char mem) ; 

// funzione che scrive l'output della codifica di Huffman
// di un token nel file compresso 
void output_token(char *token, 
		  int token_len,
		  unsigned char type) ; 

// funzione utilizzata per leggere la lista invertita dei ranghi logici e fisici
// associati ad un determinato elemento:
// number:numero dell'elemento
// logic_list:lista logica dell'elemento
// num_logic:numero delle liste logico dell'elemento 
// physic_list:lista delle posizioni fisiche dell'elemento nel 
//             file compresso
// num_physic_list:numero degli elementi nella lista fisica  
int read_list(int number, 
	      int **logic_list, 
	      int *num_logic, 
	      int **physic_list, 
	      int *num_physic) ;

int read_list_c(int number, 
		int **logic_list, 
		int *num_logic, 
		int **physic_list, 
		int *num_physic) ;
/*******************************************************************
  funzioni utilizzate per la codifica tramite algoritmo di Huffman
 *******************************************************************/ 
Hashptr *Huffman_byte_code(int *firstcw, 
			   int *offsetcw, 
			   int *count_depth);

int Sort_for_freq(const void *va, 
		  const void *vb) ;

int Sort_for_cwlen(const void *va, 
		   const void *vb) ; 

void Create_HT_leaves(Hashptr *tree, 
		      int HT_leaves) ;

int Build_HuffTree(Hashptr *work_area, 
		   int *tot_nodes, 
		   int HT_leaves) ;

int Compute_codeword_lengths(Hashptr *tree, 
			     int root, 
			     int tree_size) ;

