#include "headers1.h"

int  errori (unsigned long n1, unsigned long n2, 
	     unsigned long l1, unsigned long l2) 
{
  if (l1 != l2) {
    fprintf (stderr,"\nErrore di lunghezza (wlen=%lu, rlen=%lu) per n=%lu\n",
	     l1,l2,n1);
    return (-1); }
  if (n1 != n2) {
    fprintf (stderr,"\nErrore di compressione/decompressione per n=%lu\n",n1);
    return (-1); }
  return (0);
}


int verifica_offset (unsigned int offset)
{
  // Controlla la validita' dell'offset
  if (offset < 0 || offset > 7) {
    fprintf (stderr,"\nOffset non corretto\n");
    return (-1); 
  }
  return (0);
}


int verifica_soglia (unsigned int soglia)
{
  // Controlla la correttezza della soglia per Variable Byte
  if (soglia < 1 || soglia >= sizeof (unsigned long)) {
    fprintf (stderr,"\nValore di soglia non corretto\n");
    return (-1); 
  }
  return (0);
}


int verifica_k (unsigned long k)
{
  // Controlla la validita' del parametro k per Golomb
  const unsigned long MAX_K = 3000000000UL;

 if(k<2){ 
    fprintf (stderr,"\nErrore  nell'inserimento del parametro k: deve essere maggiore di 2\n");
    return (-1);
  }
  if(k > MAX_K){ 
    fprintf (stderr,"\nErrore  nell'inserimento del parametro k: deve essere minore di 3.000.000.000 (circe 2^32 * -0.69)\n");
    return (-1);
  }
  return (0);
}
