/* example.c -- usage example of the zlib compression library
 * Copyright (C) 1995-1998 Jean-loup Gailly.
 * For conditions of distribution and use, see copyright notice in zlib.h 
 */


#include <stdio.h>
#include "zlib.h"

#define CHECK_ERR(err, msg) { \
    if (err != Z_OK) { \
        fprintf(stderr, "%s error: %d\n", msg, err); \
        exit(1); \
    } \
}

#define CLEAN_BUF(bbb) { \
    do { \
      int iii; \
      for(iii=0; iii<BUF_SIZE; iii++) bbb[iii]=0; \
      } while(0); \
}


// Guarantee that 2Mb of buffer 
// for compression/uncompression is sufficient
#define BUF_SIZE 2000000    



int main(int argc, char *argv[])
{
    int err;

    Byte *compr, *uncompr;
    uLong comprLen,uncomprLen;
    Byte *buffer = (Byte *) calloc((uInt) BUF_SIZE, 1);

    char *pippo="aaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbaaaaaaaaaaaaaaaaaaabbbbbbbbbbbbbbbbbbbbbbbbccccccccccccccccccc";


    // Stringa da comprimere
    uncompr=(Byte *)pippo;
    uncomprLen=strlen((char *)uncompr);
    printf("stringa %s, len %d\n\n",uncompr,uncomprLen);


    // Comprime
    err = compress(buffer, &comprLen, (const Bytef*)uncompr, uncomprLen);
    CHECK_ERR(err, "compress");
    compr = (Byte*)calloc((uInt)comprLen, 1);
    memcpy(compr,buffer,comprLen);

    printf("len compressa %d\n\n",comprLen);

    CLEAN_BUF(buffer); //cleaning buffer

    // Decomprime
    err = uncompress(buffer, &uncomprLen, compr, comprLen);
    CHECK_ERR(err, "uncompress");
    uncompr = (Byte*)calloc((uInt)uncomprLen, 1);
    memcpy(uncompr,buffer,uncomprLen);

    printf("stringa decompressa %s, len %d\n\n",uncompr,uncomprLen);


    return 0;
}
