/********************************************************************
		         xcde_extract.c 
	         Xml Compressed Documents Engine
		         File Decompressor 
		 Paolo Ferragina - Andrea Mastroianni
         Dipartimento di Informatica - Universita' di Pisa 
	               ferragin@di.unipi.it
                      mastroi@cli.di.unipi.it
********************************************************************/
#include"xcde_lib.h"

int main(int argc,
	 char *argv[])
{ register
    int k=0 ;

  int res=0 ;

  int initial_position=0 ;
  
  int final_position=INT_MAX ;

  int position=0 ; 

  int cw=0 ;

  int cwlen=0 ;

  char *token=NULL ;

  unsigned 
    char body_eof_flag=0; 

  XCDE_Console_Type XCDE_Console ;

  fprintf(stderr, "\t------------------------------------------------------------------") ; 
  
  fprintf(stderr, "\n\t\t        XCDE_EXTRACT : Version 1.0 11-07-2002") ;
  
  fprintf(stderr, "\n\t\t         X.ml C.ompressed D.ocuments E.ngine") ; 
  
  fprintf(stderr, "\n\t\t        Paolo Ferragina - Andrea Mastroianni ") ;
  
  fprintf(stderr, "\n\t\t    Dipartimento di Informatica - Universita' di Pisa ") ;
  
  fprintf(stderr, "\n\t\t                 XCDE File Extractor") ;  
  
  fprintf(stderr, "\n\t------------------------------------------------------------------\n\n") ; 

  if (argc == 2)

    initial_position=0 ; 
  
  if (argc == 4) { 
    
    initial_position=atoi(argv[2]) ;
    
    final_position=atoi(argv[3]) ;
  }

  if (((argc != 2) && (argc != 4)) || (initial_position < 0) || (final_position <=0) || (final_position < initial_position)) { 

    fprintf(stderr, "\nParameters not correct\n") ;
      
    exit(-1) ; 
  }

  // opening the console
  res=XCDE_Init_Console(argv[1],
			&XCDE_Console) ; 

  if (res == -1) { 

    fprintf(stderr, "\nProblems with the XCDE_Init_Console function\n") ;
    
    exit(-1) ; 
  }

  position=initial_position ;

  while((!body_eof_flag) && (position <= final_position)) { 

    // reads the codeword in the body file at position 
    res=XCDE_Get_Body_Forward_Codeword(position,
				       &cw,
				       &cwlen,
				       &XCDE_Console) ;
    
    if (res == -1) { 

      fprintf(stderr, "\nProblems with the XCDE_Get_Body_Forward_Codeword function\n") ;
      
      fflush(stderr) ;
      
      XCDE_Finalize_Console(&XCDE_Console) ;
      
      exit(-1) ; 
    }
    
    // trasforms the codeword to the token 
    res=XCDE_Codeword2Token(cw,
			    cwlen,
			    &token,
			    &XCDE_Console) ;
    
    if (res == -1) { 

      fprintf(stderr, "\nProblems with the XCDE_Codeword2Token function\n") ;
      
      fflush(stderr) ;
      
      XCDE_Finalize_Console(&XCDE_Console) ; 
      
      exit(-1) ;
    }
    
    fprintf(stdout, "%s", token) ;
    
    fflush(stdout) ;
    
    position+=cwlen ;
    
    res=XCDE_Body_Eof(position,
		      &body_eof_flag,
		      &XCDE_Console) ; 
    
    if (res == -1) { 
 
      fprintf(stderr, "\nProblems with the XCDE_Body_Eof function\n") ;
      
      fflush(stderr) ;
      
      XCDE_Finalize_Console(&XCDE_Console) ; 
      
      exit(-1) ;
    }
    
    if (token != NULL) { 
      
      free(token) ;
      
      token=NULL ;
    }
  }
  
  // finalize console 
  res=XCDE_Finalize_Console(&XCDE_Console) ;
  
  if (res == -1) { 

    fprintf(stderr, "\nProblems with the XCDE_Get_Body_Forward_Codeword function\n") ;
    
    fflush(stderr) ;
    
    XCDE_Finalize_Console(&XCDE_Console) ;
    
    exit(-1) ; 
  }

  return(0) ;
}


    
