/********************************************************************
		           xcde_inf.c 
	         Xml Compressed Documents Engine
  	         File System Information Program
		 Paolo Ferragina - Andrea Mastroianni
         Dipartimento di Informatica - Universita' di Pisa 
	               ferragin@di.unipi.it
                      mastroi@cli.di.unipi.it
********************************************************************/
#include"xcde_lib.h"
int main(int argc,
	 char *argv[])
{ register
    int k=0 ;
 
 unsigned 
   char InitFlag=0u ; 

 unsigned 
   char Prox=0u ; 

 int Filesize=0 ; 

 char *Filename=NULL ; 
 
 int maxcwlen=0 ; 
 
 int numtokens=0 ; 
 
 int num_el=0 ; 
 
 char *token=NULL ; 
 
 int res=0 ;

 XCDE_IL_Couple_Type *IL ;

 int IL_num_el=0 ;
 
 XCDE_Console_Type XCDE_Console ; 

 fprintf(stdout, "\t------------------------------------------------------------------") ; 
  
 fprintf(stdout, "\n\t\t        XCDE_INF : Version 0.9ESP 26-02-2002") ;
 
 fprintf(stdout, "\n\t\t         X.ml C.ompressed D.ocuments E.ngine") ; 
 
 fprintf(stdout, "\n\t\t        Paolo Ferragina - Andrea Mastroianni ") ;
 
 fprintf(stdout, "\n\t\t    Dipartimento di Informatica - Universita' di Pisa ") ;
 
 fprintf(stdout, "\n\t\t            XCDE File System Information ") ;  
 
 fprintf(stdout, "\n\t------------------------------------------------------------------\n\n") ; 

 if (argc != 2)
   
   { fprintf(stderr, "\nParameters not correct\n") ;
   
   exit(-1) ; 
   }
 
 /********************************************************************
			     Opening Console
  ********************************************************************/

 res=XCDE_Init_Console(argv[1],
		       &XCDE_Console) ; 

 if (res == -1) 
   
   { fprintf(stderr, "\nProblems with the XCDE_Init_Console function\n") ;
   
   exit(-1) ; 
   }
 
 res=XCDE_ConsoleInitialized(&InitFlag,
			     &XCDE_Console) ; 
 
 if (res == -1) 

   { fprintf(stderr, "\nProblems with the XCDE_ConsoleInitialized function\n") ;
   
   fflush(stderr) ;
   
   XCDE_Finalize_Console(&XCDE_Console) ; 

   exit(-1) ; 
   }
 
 if (InitFlag) fprintf(stderr, "\nConsole initialized") ; 
  
 else fprintf(stderr, "\nConsole not initialized") ;
 
 /********************************************************************
		           Checking Proximity 
  ********************************************************************/

 res=XCDE_SettedProximity(&Prox,
			  &XCDE_Console) ;
  
  if (res == -1) 

    { fprintf(stderr, "\nProblems with the XCDE_SettedProximity function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  if (Prox) fprintf(stdout, "\nProximity lists present") ; 
  
  else fprintf(stdout, "\nProximity lists not present") ;

 /********************************************************************
                    Reading File Source Name and Size
  ********************************************************************/

  res=XCDE_Get_Source_Filename(&Filename,
			       &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Source_Filename function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }

  fprintf(stdout, "\nFile source name : %s", Filename) ; 

  res=XCDE_Get_Source_Filesize(&Filesize,
			       &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Source_Filesize function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile source size : %d", Filesize) ; 

  if (Filename != NULL) 

    free(Filename) ;
  
  /********************************************************************
                    Reading File Header Name and Size
  ********************************************************************/

  res=XCDE_Get_Header_Filename(&Filename,
			       &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Header_Filename function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile header name : %s", Filename) ; 

  res=XCDE_Get_Header_Filesize(&Filesize,
			       &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Header_Filesize function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }

  fprintf(stdout, "\nFile header size : %d bytes", Filesize) ; 

 if (Filename != NULL) 

    free(Filename) ;

 /********************************************************************
                    Reading File Body Name and Size
  ********************************************************************/

  res=XCDE_Get_Body_Filename(&Filename,
			     &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Body_Filename function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile body name : %s", Filename) ; 

  res=XCDE_Get_Body_Filesize(&Filesize,
			     &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Body_Filesize function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile body size : %d bytes", Filesize) ; 

  if (Filename != NULL) 
  
    free(Filename) ;
  
  /********************************************************************
                    Reading IL Name and Size
  ********************************************************************/

  res=XCDE_Get_IL_Filename(&Filename,
			   &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_IL_Filename function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile IL name : %s", Filename) ; 

  res=XCDE_Get_IL_Filesize(&Filesize,
			   &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_IL_Filesize function\n") ;
    
    fflush(stderr) ;
    
    XCDE_Finalize_Console(&XCDE_Console) ; 
   
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nFile IL size : %d bytes", Filesize) ; 

  if (Filename != NULL) 

    free(Filename) ;

 /********************************************************************
              Reading File TAG Dictionary Compressed Name and Size
  ********************************************************************/  

  res=XCDE_Get_Dict_Cmp_Filename(TAG,
				 &Filename,
				 &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filename function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nTAG compressed dictionary name : %s", Filename) ; 

  res=XCDE_Get_Dict_Cmp_Filesize(TAG,
				 &Filesize,
				 &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filesize function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  fprintf(stdout, "\nTAG compressed dictionary size : %d", Filesize) ; 

  if (Filename != NULL) 

    free(Filename) ;

  /********************************************************************
              Reading File ATTR Dictionary Compressed Name and Size
  ********************************************************************/ 

  res=XCDE_Get_Dict_Cmp_Filename(ATTR,
				 &Filename,
				 &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filename function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nATTR compressed dictionary name : %s", Filename) ; 

  res=XCDE_Get_Dict_Cmp_Filesize(ATTR,
				 &Filesize,
				 &XCDE_Console) ;
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filesize function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  fprintf(stdout, "\nATTR compressed dictionary size : %d", Filesize) ; 
  
  if (Filename != NULL) 

    free(Filename) ;

  /********************************************************************
              Reading File ATTR Dictionary Compressed Name and Size
  ********************************************************************/ 

  res=XCDE_Get_Dict_Cmp_Filename(WORD,
				 &Filename,
				 &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filename function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nWORD compressed dictionary name : %s", Filename) ; 
  
  res=XCDE_Get_Dict_Cmp_Filesize(WORD,
				 &Filesize,
				 &XCDE_Console) ;
  
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Dict_Cmp_Filesize function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  fprintf(stdout, "\nWORD compressed dictionary size : %d", Filesize) ; 

  /********************************************************************
                     Reading Max Codeword Length
  ********************************************************************/ 

  res=XCDE_Get_Maxcwlen(&maxcwlen,
			&XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Maxcwlen function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  fprintf(stdout, "\nMaximum codeword length : %d", maxcwlen) ; 

  /********************************************************************
                     Reading Number of Tokens
  ********************************************************************/ 

  res=XCDE_Get_Num_Tokens(&numtokens,
			  &XCDE_Console) ; 
  
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_Tokens function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of tokens : %d", numtokens) ; 
   
 /********************************************************************
                Reading Number of Elements for each level
  ********************************************************************/ 

  for (k=1 ; k<=maxcwlen; ++k)
    
    { res=XCDE_Get_Num_El_Lev(k,
			      &num_el,
			      &XCDE_Console) ; 

    if (res == -1) 
    
      { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Lev function\n") ;

      fflush(stderr) ;
   
      XCDE_Finalize_Console(&XCDE_Console) ;     

      exit(-1) ; 
      }

    fprintf(stdout, "\nNumber of elements at level %d : %d", k, num_el) ; 
    }
  
  /********************************************************************
         Reading Number of Elements for TAG - ATTR - WORD Dictionary 
  ********************************************************************/ 

  res=XCDE_Get_Num_El_Dict(TAG, 
			   &num_el,
			   &XCDE_Console) ; 

  if (res == -1) 

    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dict function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ;     

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of element in TAG dictionary : %d", num_el) ; 

  res=XCDE_Get_Num_El_Dict(ATTR,
			   &num_el,
			   &XCDE_Console) ; 

  if (res == -1) 

    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dict function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of element in ATTR dictionary : %d", num_el) ; 
  
  res=XCDE_Get_Num_El_Dict(WORD,
			   &num_el,
			   &XCDE_Console) ; 

  if (res == -1) 

    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dict function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of element in WORD dictionary : %d", num_el) ; 

  /********************************************************************
         Reading Number of TAG - ATTR - WORD Elements for each level
  ********************************************************************/ 

  for(k=1 ; k<=maxcwlen; ++k) 
   
  { res=XCDE_Get_Num_El_Dictlev(k,
				TAG,
				&num_el,
				&XCDE_Console) ; 
  if (res == -1) 

    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dictlev function\n") ;
    
    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of elements at level %d of TAG dictionary : %d ", k,num_el) ; 

  }
  
  for(k=1 ; k<=maxcwlen; ++k)  
   
  { res=XCDE_Get_Num_El_Dictlev(k,
				ATTR,
				&num_el,
				&XCDE_Console) ; 
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dictlev function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ;     

    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of elements at level %d of ATTR dictionary : %d ", k,num_el) ; 
  
  }

  for(k=1 ; k<=maxcwlen; ++k) 
   
  { res=XCDE_Get_Num_El_Dictlev(k,
				WORD,
				&num_el,
				&XCDE_Console) ; 
  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Get_Num_El_Dictlev function\n") ;

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 
    
    exit(-1) ; 
    }
  
  fprintf(stdout, "\nNumber of elements at level %d of WORD dictionary : %d ", k,num_el) ; 
  
  }

  /********************************************************************
		        Decompressing TAG Dictionary 
  ********************************************************************/ 

  res=XCDE_Decompress_Dictionary(TAG,
				 &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Decompress_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ;     

    exit(-1) ; 
    }

  /********************************************************************
		        Decompressing WORD Dictionary 
  ********************************************************************/ 


  res=XCDE_Decompress_Dictionary(WORD,
				 &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Decompress_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

 /********************************************************************
		        Decompressing ATTR Dictionary 
  ********************************************************************/ 

  res=XCDE_Decompress_Dictionary(ATTR,
				 &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Decompress_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ;     

    exit(-1) ; 
    }

 /********************************************************************
		            Loading TAG Dictionary 
  ********************************************************************/  

  res=XCDE_Load_Dictionary(TAG,
			   &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Load_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  /********************************************************************
		            Loading WORD Dictionary 
  ********************************************************************/

  res=XCDE_Load_Dictionary(WORD,
			   &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Load_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ;     

    exit(-1) ; 
    }
  
  /********************************************************************
		            Loading ATTR Dictionary 
  ********************************************************************/

  res=XCDE_Load_Dictionary(ATTR,
			   &XCDE_Console) ; 

  if (res == -1) 
    
    { fprintf(stderr, "\nProblems with the XCDE_Load_Dictionary function\n") ; 

    fflush(stderr) ;
   
    XCDE_Finalize_Console(&XCDE_Console) ; 

    exit(-1) ; 
    }

  res=XCDE_Get_IL_ListPos(482,
			  &IL,
			  &IL_num_el,
			  &XCDE_Console) ; 

  if (res == -1)
    
    { fprintf(stderr, "\nProblems in XCDE_Get_IL_ListPos") ; 
    
    fflush(stderr) ; 

    exit(-1) ; 
    }

  fprintf(stdout, "\n") ;

  for(k=0 ; k<IL_num_el; ++k) 

    fprintf(stdout, " %d ", IL[k].XCDE_Position) ; 

  /********************************************************************
 		              Finalize the Console
  ********************************************************************/

  res=XCDE_Finalize_Console(&XCDE_Console) ; 

  if (res == -1)
    
    { fprintf(stderr, "\nProblems in XCDE_Finalize_Console") ; 
    
    fflush(stderr) ; 

    exit(-1) ; 
    }
  
  fprintf(stdout, "\n") ; 

  return(0) ;
}



